/*
 * GMS REST API
 * Date: 2019-06-28 10:13:53 | Number of web services: 176
 *
 * OpenAPI spec version: 3.1.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.ErrorDto;
import java.io.File;
import io.swagger.client.model.GatewayConfigurationDto;
import io.swagger.client.model.GatewayConnectionDto;
import io.swagger.client.model.GatewayControlDto;
import io.swagger.client.model.GatewayDto;
import io.swagger.client.model.GatewayManagementDto;
import io.swagger.client.model.GatewayStatisticsDto;
import io.swagger.client.model.GatewayVersionDto;
import io.swagger.client.model.LnsGatewayKeyDto;
import io.swagger.client.model.PaginatedDto;
import io.swagger.client.model.ProgressMonitorDto;
import io.swagger.client.model.TaskDto;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;
import io.swagger.client.model.GatewayConfigurationDto;
import io.swagger.client.model.GatewayConnectionDto;
import io.swagger.client.model.GatewayControlDto;
import io.swagger.client.model.GatewayDto;
import io.swagger.client.model.GatewayEventDto;
import io.swagger.client.model.GatewayManagementDto;
import io.swagger.client.model.GatewayModemStatisticDto;
import io.swagger.client.model.GatewayNumericStatisticsDto;
import io.swagger.client.model.GatewaySnmpLogDto;
import io.swagger.client.model.GatewayStatisticsDto;
import io.swagger.client.model.GatewayTermStatisticsDto;
import io.swagger.client.model.GatewayVersionDto;
import io.swagger.client.model.KpiDto;
import io.swagger.client.model.LastEventDto;
import io.swagger.client.model.LastOperationDto;
import io.swagger.client.model.LastStatisticDto;
import io.swagger.client.model.LnsGatewayKeyDto;
import io.swagger.client.model.PaginatedDto;
import io.swagger.client.model.ProgressMonitorDto;
import io.swagger.client.model.TaskDto;

public class GatewaysApi {
    private ApiClient apiClient;

    public GatewaysApi() {
        this(Configuration.getDefaultApiClient());
    }

    public GatewaysApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for createGateway
     * @param body The DTO JSON representation to put in the request body (required)
     * @param eui Gateway EUI (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call createGatewayCall(GatewayDto body, String eui, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/{eui}"
            .replaceAll("\\{" + "eui" + "\\}", apiClient.escapeString(eui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call createGatewayValidateBeforeCall(GatewayDto body, String eui, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling createGateway(Async)");
        }
        // verify the required parameter 'eui' is set
        if (eui == null) {
            throw new ApiException("Missing the required parameter 'eui' when calling createGateway(Async)");
        }
        
        com.squareup.okhttp.Call call = createGatewayCall(body, eui, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * createGateway
     * This web service allows to create a new gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;li&gt;The fields {allowGPSPosition, maxTxPower, networkMaxDelayDown, networkMaxDelayUp} are set if the user is at least ADMIN.&lt;/li&gt;&lt;li&gt;The maximum number of gateways of the customer cannot be exceeded.&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param body The DTO JSON representation to put in the request body (required)
     * @param eui Gateway EUI (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void createGateway(GatewayDto body, String eui) throws ApiException {
        createGatewayWithHttpInfo(body, eui);
    }

    /**
     * createGateway
     * This web service allows to create a new gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;li&gt;The fields {allowGPSPosition, maxTxPower, networkMaxDelayDown, networkMaxDelayUp} are set if the user is at least ADMIN.&lt;/li&gt;&lt;li&gt;The maximum number of gateways of the customer cannot be exceeded.&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param body The DTO JSON representation to put in the request body (required)
     * @param eui Gateway EUI (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> createGatewayWithHttpInfo(GatewayDto body, String eui) throws ApiException {
        com.squareup.okhttp.Call call = createGatewayValidateBeforeCall(body, eui, null, null);
        return apiClient.execute(call);
    }

    /**
     * createGateway (asynchronously)
     * This web service allows to create a new gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;li&gt;The fields {allowGPSPosition, maxTxPower, networkMaxDelayDown, networkMaxDelayUp} are set if the user is at least ADMIN.&lt;/li&gt;&lt;li&gt;The maximum number of gateways of the customer cannot be exceeded.&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param body The DTO JSON representation to put in the request body (required)
     * @param eui Gateway EUI (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call createGatewayAsync(GatewayDto body, String eui, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = createGatewayValidateBeforeCall(body, eui, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for createGatewayCommand
     * @param command The Linux command to execute (required)
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call createGatewayCommandCall(String command, String eui, Object criteria, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/{eui}/commands"
            .replaceAll("\\{" + "eui" + "\\}", apiClient.escapeString(eui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (command != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("command", command));
        if (criteria != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("criteria", criteria));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call createGatewayCommandValidateBeforeCall(String command, String eui, Object criteria, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'command' is set
        if (command == null) {
            throw new ApiException("Missing the required parameter 'command' when calling createGatewayCommand(Async)");
        }
        // verify the required parameter 'eui' is set
        if (eui == null) {
            throw new ApiException("Missing the required parameter 'eui' when calling createGatewayCommand(Async)");
        }
        
        com.squareup.okhttp.Call call = createGatewayCommandCall(command, eui, criteria, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * createGatewayCommand
     * This web services allows to execute a command on the remote gateway.&lt;br&gt;Caution : only the commands based on a request &lt;&#x3D;&gt; response will be correctly managed; a command like vi file.txt will not work as it needs an interactive mode.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param command The Linux command to execute (required)
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @return TaskDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public TaskDto createGatewayCommand(String command, String eui, Object criteria) throws ApiException {
        ApiResponse<TaskDto> resp = createGatewayCommandWithHttpInfo(command, eui, criteria);
        return resp.getData();
    }

    /**
     * createGatewayCommand
     * This web services allows to execute a command on the remote gateway.&lt;br&gt;Caution : only the commands based on a request &lt;&#x3D;&gt; response will be correctly managed; a command like vi file.txt will not work as it needs an interactive mode.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param command The Linux command to execute (required)
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @return ApiResponse&lt;TaskDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<TaskDto> createGatewayCommandWithHttpInfo(String command, String eui, Object criteria) throws ApiException {
        com.squareup.okhttp.Call call = createGatewayCommandValidateBeforeCall(command, eui, criteria, null, null);
        Type localVarReturnType = new TypeToken<TaskDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * createGatewayCommand (asynchronously)
     * This web services allows to execute a command on the remote gateway.&lt;br&gt;Caution : only the commands based on a request &lt;&#x3D;&gt; response will be correctly managed; a command like vi file.txt will not work as it needs an interactive mode.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param command The Linux command to execute (required)
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call createGatewayCommandAsync(String command, String eui, Object criteria, final ApiCallback<TaskDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = createGatewayCommandValidateBeforeCall(command, eui, criteria, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<TaskDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for createGatewayCpCommand
     * @param destination Absolute directory destination where to copy source (required)
     * @param eui Gateway EUI (required)
     * @param source absolute source path to copy (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call createGatewayCpCommandCall(String destination, String eui, String source, Object criteria, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/{eui}/commands/cp"
            .replaceAll("\\{" + "eui" + "\\}", apiClient.escapeString(eui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (criteria != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("criteria", criteria));
        if (destination != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("destination", destination));
        if (source != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("source", source));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call createGatewayCpCommandValidateBeforeCall(String destination, String eui, String source, Object criteria, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'destination' is set
        if (destination == null) {
            throw new ApiException("Missing the required parameter 'destination' when calling createGatewayCpCommand(Async)");
        }
        // verify the required parameter 'eui' is set
        if (eui == null) {
            throw new ApiException("Missing the required parameter 'eui' when calling createGatewayCpCommand(Async)");
        }
        // verify the required parameter 'source' is set
        if (source == null) {
            throw new ApiException("Missing the required parameter 'source' when calling createGatewayCpCommand(Async)");
        }
        
        com.squareup.okhttp.Call call = createGatewayCpCommandCall(destination, eui, source, criteria, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * createGatewayCpCommand
     * This web service allows to copy file from source to destination on a gateway.&lt;br&gt;If the source contains sub directories they will be recursively copied.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param destination Absolute directory destination where to copy source (required)
     * @param eui Gateway EUI (required)
     * @param source absolute source path to copy (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @return TaskDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public TaskDto createGatewayCpCommand(String destination, String eui, String source, Object criteria) throws ApiException {
        ApiResponse<TaskDto> resp = createGatewayCpCommandWithHttpInfo(destination, eui, source, criteria);
        return resp.getData();
    }

    /**
     * createGatewayCpCommand
     * This web service allows to copy file from source to destination on a gateway.&lt;br&gt;If the source contains sub directories they will be recursively copied.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param destination Absolute directory destination where to copy source (required)
     * @param eui Gateway EUI (required)
     * @param source absolute source path to copy (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @return ApiResponse&lt;TaskDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<TaskDto> createGatewayCpCommandWithHttpInfo(String destination, String eui, String source, Object criteria) throws ApiException {
        com.squareup.okhttp.Call call = createGatewayCpCommandValidateBeforeCall(destination, eui, source, criteria, null, null);
        Type localVarReturnType = new TypeToken<TaskDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * createGatewayCpCommand (asynchronously)
     * This web service allows to copy file from source to destination on a gateway.&lt;br&gt;If the source contains sub directories they will be recursively copied.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param destination Absolute directory destination where to copy source (required)
     * @param eui Gateway EUI (required)
     * @param source absolute source path to copy (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call createGatewayCpCommandAsync(String destination, String eui, String source, Object criteria, final ApiCallback<TaskDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = createGatewayCpCommandValidateBeforeCall(destination, eui, source, criteria, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<TaskDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for createGatewayGetFileCommand
     * @param eui Gateway EUI (required)
     * @param filePath absolute path of the gateway file (ex: /tmp/conf/foo.txt) (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call createGatewayGetFileCommandCall(String eui, String filePath, Object criteria, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/{eui}/commands/get"
            .replaceAll("\\{" + "eui" + "\\}", apiClient.escapeString(eui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (criteria != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("criteria", criteria));
        if (filePath != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("filePath", filePath));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call createGatewayGetFileCommandValidateBeforeCall(String eui, String filePath, Object criteria, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'eui' is set
        if (eui == null) {
            throw new ApiException("Missing the required parameter 'eui' when calling createGatewayGetFileCommand(Async)");
        }
        // verify the required parameter 'filePath' is set
        if (filePath == null) {
            throw new ApiException("Missing the required parameter 'filePath' when calling createGatewayGetFileCommand(Async)");
        }
        
        com.squareup.okhttp.Call call = createGatewayGetFileCommandCall(eui, filePath, criteria, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * createGatewayGetFileCommand
     * This web service allows to retrieve a file from the gateway file system.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param filePath absolute path of the gateway file (ex: /tmp/conf/foo.txt) (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @return TaskDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public TaskDto createGatewayGetFileCommand(String eui, String filePath, Object criteria) throws ApiException {
        ApiResponse<TaskDto> resp = createGatewayGetFileCommandWithHttpInfo(eui, filePath, criteria);
        return resp.getData();
    }

    /**
     * createGatewayGetFileCommand
     * This web service allows to retrieve a file from the gateway file system.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param filePath absolute path of the gateway file (ex: /tmp/conf/foo.txt) (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @return ApiResponse&lt;TaskDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<TaskDto> createGatewayGetFileCommandWithHttpInfo(String eui, String filePath, Object criteria) throws ApiException {
        com.squareup.okhttp.Call call = createGatewayGetFileCommandValidateBeforeCall(eui, filePath, criteria, null, null);
        Type localVarReturnType = new TypeToken<TaskDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * createGatewayGetFileCommand (asynchronously)
     * This web service allows to retrieve a file from the gateway file system.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param filePath absolute path of the gateway file (ex: /tmp/conf/foo.txt) (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call createGatewayGetFileCommandAsync(String eui, String filePath, Object criteria, final ApiCallback<TaskDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = createGatewayGetFileCommandValidateBeforeCall(eui, filePath, criteria, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<TaskDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for createGatewayLsCommand
     * @param directory The absolute path to browse (example : /tmp/dir) (required)
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param fields List of fields to display for FileDto (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call createGatewayLsCommandCall(String directory, String eui, Object criteria, String fields, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/{eui}/commands/ls"
            .replaceAll("\\{" + "eui" + "\\}", apiClient.escapeString(eui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (criteria != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("criteria", criteria));
        if (directory != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("directory", directory));
        if (fields != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fields", fields));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call createGatewayLsCommandValidateBeforeCall(String directory, String eui, Object criteria, String fields, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'directory' is set
        if (directory == null) {
            throw new ApiException("Missing the required parameter 'directory' when calling createGatewayLsCommand(Async)");
        }
        // verify the required parameter 'eui' is set
        if (eui == null) {
            throw new ApiException("Missing the required parameter 'eui' when calling createGatewayLsCommand(Async)");
        }
        
        com.squareup.okhttp.Call call = createGatewayLsCommandCall(directory, eui, criteria, fields, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * createGatewayLsCommand
     * This web service allows to execute the command &#x27;ls&#x27; on the gateway. It browses the directory non recursively.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param directory The absolute path to browse (example : /tmp/dir) (required)
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param fields List of fields to display for FileDto (optional)
     * @return TaskDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public TaskDto createGatewayLsCommand(String directory, String eui, Object criteria, String fields) throws ApiException {
        ApiResponse<TaskDto> resp = createGatewayLsCommandWithHttpInfo(directory, eui, criteria, fields);
        return resp.getData();
    }

    /**
     * createGatewayLsCommand
     * This web service allows to execute the command &#x27;ls&#x27; on the gateway. It browses the directory non recursively.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param directory The absolute path to browse (example : /tmp/dir) (required)
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param fields List of fields to display for FileDto (optional)
     * @return ApiResponse&lt;TaskDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<TaskDto> createGatewayLsCommandWithHttpInfo(String directory, String eui, Object criteria, String fields) throws ApiException {
        com.squareup.okhttp.Call call = createGatewayLsCommandValidateBeforeCall(directory, eui, criteria, fields, null, null);
        Type localVarReturnType = new TypeToken<TaskDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * createGatewayLsCommand (asynchronously)
     * This web service allows to execute the command &#x27;ls&#x27; on the gateway. It browses the directory non recursively.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param directory The absolute path to browse (example : /tmp/dir) (required)
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param fields List of fields to display for FileDto (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call createGatewayLsCommandAsync(String directory, String eui, Object criteria, String fields, final ApiCallback<TaskDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = createGatewayLsCommandValidateBeforeCall(directory, eui, criteria, fields, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<TaskDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for createGatewayMkDirCommand
     * @param directory absolute path of the directory to create (ex: /tmp/conf) (required)
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call createGatewayMkDirCommandCall(String directory, String eui, Object criteria, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/{eui}/commands/mkdir"
            .replaceAll("\\{" + "eui" + "\\}", apiClient.escapeString(eui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (criteria != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("criteria", criteria));
        if (directory != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("directory", directory));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call createGatewayMkDirCommandValidateBeforeCall(String directory, String eui, Object criteria, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'directory' is set
        if (directory == null) {
            throw new ApiException("Missing the required parameter 'directory' when calling createGatewayMkDirCommand(Async)");
        }
        // verify the required parameter 'eui' is set
        if (eui == null) {
            throw new ApiException("Missing the required parameter 'eui' when calling createGatewayMkDirCommand(Async)");
        }
        
        com.squareup.okhttp.Call call = createGatewayMkDirCommandCall(directory, eui, criteria, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * createGatewayMkDirCommand
     * This web service allows to execute the command mkdir on one gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param directory absolute path of the directory to create (ex: /tmp/conf) (required)
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @return TaskDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public TaskDto createGatewayMkDirCommand(String directory, String eui, Object criteria) throws ApiException {
        ApiResponse<TaskDto> resp = createGatewayMkDirCommandWithHttpInfo(directory, eui, criteria);
        return resp.getData();
    }

    /**
     * createGatewayMkDirCommand
     * This web service allows to execute the command mkdir on one gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param directory absolute path of the directory to create (ex: /tmp/conf) (required)
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @return ApiResponse&lt;TaskDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<TaskDto> createGatewayMkDirCommandWithHttpInfo(String directory, String eui, Object criteria) throws ApiException {
        com.squareup.okhttp.Call call = createGatewayMkDirCommandValidateBeforeCall(directory, eui, criteria, null, null);
        Type localVarReturnType = new TypeToken<TaskDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * createGatewayMkDirCommand (asynchronously)
     * This web service allows to execute the command mkdir on one gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param directory absolute path of the directory to create (ex: /tmp/conf) (required)
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call createGatewayMkDirCommandAsync(String directory, String eui, Object criteria, final ApiCallback<TaskDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = createGatewayMkDirCommandValidateBeforeCall(directory, eui, criteria, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<TaskDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for createGatewayModemSpectrum
     * @param duration Duration of the spectrum analysis in seconds (integer &gt; 0 and &lt; 86400) (required)
     * @param eui Gateway EUI (required)
     * @param modemLocation Modem location (starting at 1) (required)
     * @param modemSerialNumber Modem serial number (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call createGatewayModemSpectrumCall(Integer duration, String eui, Integer modemLocation, String modemSerialNumber, Object criteria, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/{eui}/modems/{modemLocation}/spectrums"
            .replaceAll("\\{" + "eui" + "\\}", apiClient.escapeString(eui.toString()))
            .replaceAll("\\{" + "modemLocation" + "\\}", apiClient.escapeString(modemLocation.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (criteria != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("criteria", criteria));
        if (duration != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("duration", duration));
        if (modemSerialNumber != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("modemSerialNumber", modemSerialNumber));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call createGatewayModemSpectrumValidateBeforeCall(Integer duration, String eui, Integer modemLocation, String modemSerialNumber, Object criteria, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'duration' is set
        if (duration == null) {
            throw new ApiException("Missing the required parameter 'duration' when calling createGatewayModemSpectrum(Async)");
        }
        // verify the required parameter 'eui' is set
        if (eui == null) {
            throw new ApiException("Missing the required parameter 'eui' when calling createGatewayModemSpectrum(Async)");
        }
        // verify the required parameter 'modemLocation' is set
        if (modemLocation == null) {
            throw new ApiException("Missing the required parameter 'modemLocation' when calling createGatewayModemSpectrum(Async)");
        }
        // verify the required parameter 'modemSerialNumber' is set
        if (modemSerialNumber == null) {
            throw new ApiException("Missing the required parameter 'modemSerialNumber' when calling createGatewayModemSpectrum(Async)");
        }
        
        com.squareup.okhttp.Call call = createGatewayModemSpectrumCall(duration, eui, modemLocation, modemSerialNumber, criteria, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * createGatewayModemSpectrum
     * This web service allows to create a new spectrum analysis on one modem of the gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param duration Duration of the spectrum analysis in seconds (integer &gt; 0 and &lt; 86400) (required)
     * @param eui Gateway EUI (required)
     * @param modemLocation Modem location (starting at 1) (required)
     * @param modemSerialNumber Modem serial number (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @return TaskDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public TaskDto createGatewayModemSpectrum(Integer duration, String eui, Integer modemLocation, String modemSerialNumber, Object criteria) throws ApiException {
        ApiResponse<TaskDto> resp = createGatewayModemSpectrumWithHttpInfo(duration, eui, modemLocation, modemSerialNumber, criteria);
        return resp.getData();
    }

    /**
     * createGatewayModemSpectrum
     * This web service allows to create a new spectrum analysis on one modem of the gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param duration Duration of the spectrum analysis in seconds (integer &gt; 0 and &lt; 86400) (required)
     * @param eui Gateway EUI (required)
     * @param modemLocation Modem location (starting at 1) (required)
     * @param modemSerialNumber Modem serial number (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @return ApiResponse&lt;TaskDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<TaskDto> createGatewayModemSpectrumWithHttpInfo(Integer duration, String eui, Integer modemLocation, String modemSerialNumber, Object criteria) throws ApiException {
        com.squareup.okhttp.Call call = createGatewayModemSpectrumValidateBeforeCall(duration, eui, modemLocation, modemSerialNumber, criteria, null, null);
        Type localVarReturnType = new TypeToken<TaskDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * createGatewayModemSpectrum (asynchronously)
     * This web service allows to create a new spectrum analysis on one modem of the gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param duration Duration of the spectrum analysis in seconds (integer &gt; 0 and &lt; 86400) (required)
     * @param eui Gateway EUI (required)
     * @param modemLocation Modem location (starting at 1) (required)
     * @param modemSerialNumber Modem serial number (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call createGatewayModemSpectrumAsync(Integer duration, String eui, Integer modemLocation, String modemSerialNumber, Object criteria, final ApiCallback<TaskDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = createGatewayModemSpectrumValidateBeforeCall(duration, eui, modemLocation, modemSerialNumber, criteria, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<TaskDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for createGatewayMvCommand
     * @param destination Absolute destination path of the new name or the destination directory (required)
     * @param eui Gateway EUI (required)
     * @param source absolute source path to move or rename (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call createGatewayMvCommandCall(String destination, String eui, String source, Object criteria, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/{eui}/commands/mv"
            .replaceAll("\\{" + "eui" + "\\}", apiClient.escapeString(eui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (criteria != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("criteria", criteria));
        if (destination != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("destination", destination));
        if (source != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("source", source));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call createGatewayMvCommandValidateBeforeCall(String destination, String eui, String source, Object criteria, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'destination' is set
        if (destination == null) {
            throw new ApiException("Missing the required parameter 'destination' when calling createGatewayMvCommand(Async)");
        }
        // verify the required parameter 'eui' is set
        if (eui == null) {
            throw new ApiException("Missing the required parameter 'eui' when calling createGatewayMvCommand(Async)");
        }
        // verify the required parameter 'source' is set
        if (source == null) {
            throw new ApiException("Missing the required parameter 'source' when calling createGatewayMvCommand(Async)");
        }
        
        com.squareup.okhttp.Call call = createGatewayMvCommandCall(destination, eui, source, criteria, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * createGatewayMvCommand
     * This web service allows to rename or move a file on a gateway.Examples &lt;br&gt;mv /tmp/foo.txt /tmp/foo2.txt : renames foo.txt to foo2.txt&lt;br&gt;mv /tmp/foo.txt /tmp/subdir : moves foo.txt to /tmp/subdir directory&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param destination Absolute destination path of the new name or the destination directory (required)
     * @param eui Gateway EUI (required)
     * @param source absolute source path to move or rename (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @return TaskDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public TaskDto createGatewayMvCommand(String destination, String eui, String source, Object criteria) throws ApiException {
        ApiResponse<TaskDto> resp = createGatewayMvCommandWithHttpInfo(destination, eui, source, criteria);
        return resp.getData();
    }

    /**
     * createGatewayMvCommand
     * This web service allows to rename or move a file on a gateway.Examples &lt;br&gt;mv /tmp/foo.txt /tmp/foo2.txt : renames foo.txt to foo2.txt&lt;br&gt;mv /tmp/foo.txt /tmp/subdir : moves foo.txt to /tmp/subdir directory&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param destination Absolute destination path of the new name or the destination directory (required)
     * @param eui Gateway EUI (required)
     * @param source absolute source path to move or rename (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @return ApiResponse&lt;TaskDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<TaskDto> createGatewayMvCommandWithHttpInfo(String destination, String eui, String source, Object criteria) throws ApiException {
        com.squareup.okhttp.Call call = createGatewayMvCommandValidateBeforeCall(destination, eui, source, criteria, null, null);
        Type localVarReturnType = new TypeToken<TaskDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * createGatewayMvCommand (asynchronously)
     * This web service allows to rename or move a file on a gateway.Examples &lt;br&gt;mv /tmp/foo.txt /tmp/foo2.txt : renames foo.txt to foo2.txt&lt;br&gt;mv /tmp/foo.txt /tmp/subdir : moves foo.txt to /tmp/subdir directory&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param destination Absolute destination path of the new name or the destination directory (required)
     * @param eui Gateway EUI (required)
     * @param source absolute source path to move or rename (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call createGatewayMvCommandAsync(String destination, String eui, String source, Object criteria, final ApiCallback<TaskDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = createGatewayMvCommandValidateBeforeCall(destination, eui, source, criteria, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<TaskDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for createGatewayPutFileCommand
     * @param file  (required)
     * @param destinationPath absolute path of the gateway directory that will receive the file (ex: /tmp/destination) (required)
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call createGatewayPutFileCommandCall(File file, String destinationPath, String eui, Object criteria, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/{eui}/commands/put"
            .replaceAll("\\{" + "eui" + "\\}", apiClient.escapeString(eui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (criteria != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("criteria", criteria));
        if (destinationPath != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("destinationPath", destinationPath));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (file != null)
        localVarFormParams.put("file", file);

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "multipart/form-data"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call createGatewayPutFileCommandValidateBeforeCall(File file, String destinationPath, String eui, Object criteria, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'file' is set
        if (file == null) {
            throw new ApiException("Missing the required parameter 'file' when calling createGatewayPutFileCommand(Async)");
        }
        // verify the required parameter 'destinationPath' is set
        if (destinationPath == null) {
            throw new ApiException("Missing the required parameter 'destinationPath' when calling createGatewayPutFileCommand(Async)");
        }
        // verify the required parameter 'eui' is set
        if (eui == null) {
            throw new ApiException("Missing the required parameter 'eui' when calling createGatewayPutFileCommand(Async)");
        }
        
        com.squareup.okhttp.Call call = createGatewayPutFileCommandCall(file, destinationPath, eui, criteria, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * createGatewayPutFileCommand
     * This web service allows to put a file on the gateway file system.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param file  (required)
     * @param destinationPath absolute path of the gateway directory that will receive the file (ex: /tmp/destination) (required)
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @return TaskDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public TaskDto createGatewayPutFileCommand(File file, String destinationPath, String eui, Object criteria) throws ApiException {
        ApiResponse<TaskDto> resp = createGatewayPutFileCommandWithHttpInfo(file, destinationPath, eui, criteria);
        return resp.getData();
    }

    /**
     * createGatewayPutFileCommand
     * This web service allows to put a file on the gateway file system.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param file  (required)
     * @param destinationPath absolute path of the gateway directory that will receive the file (ex: /tmp/destination) (required)
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @return ApiResponse&lt;TaskDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<TaskDto> createGatewayPutFileCommandWithHttpInfo(File file, String destinationPath, String eui, Object criteria) throws ApiException {
        com.squareup.okhttp.Call call = createGatewayPutFileCommandValidateBeforeCall(file, destinationPath, eui, criteria, null, null);
        Type localVarReturnType = new TypeToken<TaskDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * createGatewayPutFileCommand (asynchronously)
     * This web service allows to put a file on the gateway file system.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param file  (required)
     * @param destinationPath absolute path of the gateway directory that will receive the file (ex: /tmp/destination) (required)
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call createGatewayPutFileCommandAsync(File file, String destinationPath, String eui, Object criteria, final ApiCallback<TaskDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = createGatewayPutFileCommandValidateBeforeCall(file, destinationPath, eui, criteria, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<TaskDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for createGatewayRmCommand
     * @param eui Gateway EUI (required)
     * @param file Absolute path of the file to delete (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call createGatewayRmCommandCall(String eui, String file, Object criteria, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/{eui}/commands/rm"
            .replaceAll("\\{" + "eui" + "\\}", apiClient.escapeString(eui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (criteria != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("criteria", criteria));
        if (file != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("file", file));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call createGatewayRmCommandValidateBeforeCall(String eui, String file, Object criteria, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'eui' is set
        if (eui == null) {
            throw new ApiException("Missing the required parameter 'eui' when calling createGatewayRmCommand(Async)");
        }
        // verify the required parameter 'file' is set
        if (file == null) {
            throw new ApiException("Missing the required parameter 'file' when calling createGatewayRmCommand(Async)");
        }
        
        com.squareup.okhttp.Call call = createGatewayRmCommandCall(eui, file, criteria, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * createGatewayRmCommand
     * This web service allows to delete file on a gateway.Examples &lt;br&gt;rm /tmp/foo.txt : deletes the file foo.txt&lt;br&gt;rv /tmp : deletes /tmp directory&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param file Absolute path of the file to delete (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @return TaskDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public TaskDto createGatewayRmCommand(String eui, String file, Object criteria) throws ApiException {
        ApiResponse<TaskDto> resp = createGatewayRmCommandWithHttpInfo(eui, file, criteria);
        return resp.getData();
    }

    /**
     * createGatewayRmCommand
     * This web service allows to delete file on a gateway.Examples &lt;br&gt;rm /tmp/foo.txt : deletes the file foo.txt&lt;br&gt;rv /tmp : deletes /tmp directory&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param file Absolute path of the file to delete (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @return ApiResponse&lt;TaskDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<TaskDto> createGatewayRmCommandWithHttpInfo(String eui, String file, Object criteria) throws ApiException {
        com.squareup.okhttp.Call call = createGatewayRmCommandValidateBeforeCall(eui, file, criteria, null, null);
        Type localVarReturnType = new TypeToken<TaskDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * createGatewayRmCommand (asynchronously)
     * This web service allows to delete file on a gateway.Examples &lt;br&gt;rm /tmp/foo.txt : deletes the file foo.txt&lt;br&gt;rv /tmp : deletes /tmp directory&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param file Absolute path of the file to delete (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call createGatewayRmCommandAsync(String eui, String file, Object criteria, final ApiCallback<TaskDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = createGatewayRmCommandValidateBeforeCall(eui, file, criteria, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<TaskDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for createGateways
     * @param file  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call createGatewaysCall(File file, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/bulk";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (file != null)
        localVarFormParams.put("file", file);

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "multipart/form-data"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call createGatewaysValidateBeforeCall(File file, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'file' is set
        if (file == null) {
            throw new ApiException("Missing the required parameter 'file' when calling createGateways(Async)");
        }
        
        com.squareup.okhttp.Call call = createGatewaysCall(file, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * createGateways
     * Creates several gateways from a CSV file for one ore more customers. The CSV file contains a list of CsvGatewayDto.&lt;br&gt;This web service is asynchronous. It sends a 202 Accepted response and the header Location allows to request for the progress monitoring returned by the web service getCreateGatewaysStatus&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;li&gt;The already exist gateways are ignored.&lt;/li&gt;&lt;li&gt;The fields {allowGPSPosition, maxTxPower, networkMaxDelayDown, networkMaxDelayUp} are set if the user is at least ADMIN, otherwise an error is returned.&lt;/li&gt;&lt;li&gt;If the customer has a limited number of gateways, then this limit cannot be exceeded.&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v2.1.0&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param file  (required)
     * @return String
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public String createGateways(File file) throws ApiException {
        ApiResponse<String> resp = createGatewaysWithHttpInfo(file);
        return resp.getData();
    }

    /**
     * createGateways
     * Creates several gateways from a CSV file for one ore more customers. The CSV file contains a list of CsvGatewayDto.&lt;br&gt;This web service is asynchronous. It sends a 202 Accepted response and the header Location allows to request for the progress monitoring returned by the web service getCreateGatewaysStatus&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;li&gt;The already exist gateways are ignored.&lt;/li&gt;&lt;li&gt;The fields {allowGPSPosition, maxTxPower, networkMaxDelayDown, networkMaxDelayUp} are set if the user is at least ADMIN, otherwise an error is returned.&lt;/li&gt;&lt;li&gt;If the customer has a limited number of gateways, then this limit cannot be exceeded.&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v2.1.0&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param file  (required)
     * @return ApiResponse&lt;String&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<String> createGatewaysWithHttpInfo(File file) throws ApiException {
        com.squareup.okhttp.Call call = createGatewaysValidateBeforeCall(file, null, null);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * createGateways (asynchronously)
     * Creates several gateways from a CSV file for one ore more customers. The CSV file contains a list of CsvGatewayDto.&lt;br&gt;This web service is asynchronous. It sends a 202 Accepted response and the header Location allows to request for the progress monitoring returned by the web service getCreateGatewaysStatus&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;li&gt;The already exist gateways are ignored.&lt;/li&gt;&lt;li&gt;The fields {allowGPSPosition, maxTxPower, networkMaxDelayDown, networkMaxDelayUp} are set if the user is at least ADMIN, otherwise an error is returned.&lt;/li&gt;&lt;li&gt;If the customer has a limited number of gateways, then this limit cannot be exceeded.&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v2.1.0&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param file  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call createGatewaysAsync(File file, final ApiCallback<String> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = createGatewaysValidateBeforeCall(file, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for createGatewaysDeletion
     * @param body The list of gateways eui (Example : [&quot;AAAAAAAAAAAAAA16&quot;,&quot;BBBBBBBBBBBBBB16&quot;,&quot;CCCCCCCCCCCCCC16&quot;]) (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call createGatewaysDeletionCall(List<String> body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/deletions";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call createGatewaysDeletionValidateBeforeCall(List<String> body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling createGatewaysDeletion(Async)");
        }
        
        com.squareup.okhttp.Call call = createGatewaysDeletionCall(body, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * createGatewaysDeletion
     * This web service deletes a list of gateways.&lt;br&gt;This web service is asynchronous. It sends a 202 Accepted response and the header Location allows to request for the progress monitoring.&lt;br&gt;The request body contains an array of eui.&lt;br&gt;If errors occur, the result field of the ProgressMonitorDto contains the set of gateway identifiers which are on error.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v2.2.0&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param body The list of gateways eui (Example : [&quot;AAAAAAAAAAAAAA16&quot;,&quot;BBBBBBBBBBBBBB16&quot;,&quot;CCCCCCCCCCCCCC16&quot;]) (required)
     * @return String
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public String createGatewaysDeletion(List<String> body) throws ApiException {
        ApiResponse<String> resp = createGatewaysDeletionWithHttpInfo(body);
        return resp.getData();
    }

    /**
     * createGatewaysDeletion
     * This web service deletes a list of gateways.&lt;br&gt;This web service is asynchronous. It sends a 202 Accepted response and the header Location allows to request for the progress monitoring.&lt;br&gt;The request body contains an array of eui.&lt;br&gt;If errors occur, the result field of the ProgressMonitorDto contains the set of gateway identifiers which are on error.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v2.2.0&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param body The list of gateways eui (Example : [&quot;AAAAAAAAAAAAAA16&quot;,&quot;BBBBBBBBBBBBBB16&quot;,&quot;CCCCCCCCCCCCCC16&quot;]) (required)
     * @return ApiResponse&lt;String&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<String> createGatewaysDeletionWithHttpInfo(List<String> body) throws ApiException {
        com.squareup.okhttp.Call call = createGatewaysDeletionValidateBeforeCall(body, null, null);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * createGatewaysDeletion (asynchronously)
     * This web service deletes a list of gateways.&lt;br&gt;This web service is asynchronous. It sends a 202 Accepted response and the header Location allows to request for the progress monitoring.&lt;br&gt;The request body contains an array of eui.&lt;br&gt;If errors occur, the result field of the ProgressMonitorDto contains the set of gateway identifiers which are on error.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v2.2.0&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param body The list of gateways eui (Example : [&quot;AAAAAAAAAAAAAA16&quot;,&quot;BBBBBBBBBBBBBB16&quot;,&quot;CCCCCCCCCCCCCC16&quot;]) (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call createGatewaysDeletionAsync(List<String> body, final ApiCallback<String> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = createGatewaysDeletionValidateBeforeCall(body, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for createGatewaysExport
     * @param fields List of fields to display (optional)
     * @param importable true means that csv is importable from web service createGateways. (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call createGatewaysExportCall(String fields, Boolean importable, String search, String sort, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/exports";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (fields != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fields", fields));
        if (importable != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("importable", importable));
        if (search != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("search", search));
        if (sort != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("sort", sort));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call createGatewaysExportValidateBeforeCall(String fields, Boolean importable, String search, String sort, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        com.squareup.okhttp.Call call = createGatewaysExportCall(fields, importable, search, sort, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * createGatewaysExport
     * This web service allows to export the gateways to a CSV file.&lt;br&gt;This web service is asynchronous. It sends a 202 Accepted response status.&lt;br&gt;The response header Content-Location allows to poll the ProgressMonitorDto with the web service getGatewaysExport.&lt;br&gt;The parameters sort and search refer to a GatewayDto.&lt;br&gt;The generated CSV file is a list of CsvGatewayDto.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;li&gt;If the connected user is SUPER_ADMIN then all gateways are exported, otherwise only the gateways attached to his customer.&lt;/li&gt;&lt;li&gt;If the parameter importable is set to true, then the csv file will contain only the authorized fields of a CsvGatewayDto.&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v2.2.0&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param fields List of fields to display (optional)
     * @param importable true means that csv is importable from web service createGateways. (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @return String
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public String createGatewaysExport(String fields, Boolean importable, String search, String sort) throws ApiException {
        ApiResponse<String> resp = createGatewaysExportWithHttpInfo(fields, importable, search, sort);
        return resp.getData();
    }

    /**
     * createGatewaysExport
     * This web service allows to export the gateways to a CSV file.&lt;br&gt;This web service is asynchronous. It sends a 202 Accepted response status.&lt;br&gt;The response header Content-Location allows to poll the ProgressMonitorDto with the web service getGatewaysExport.&lt;br&gt;The parameters sort and search refer to a GatewayDto.&lt;br&gt;The generated CSV file is a list of CsvGatewayDto.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;li&gt;If the connected user is SUPER_ADMIN then all gateways are exported, otherwise only the gateways attached to his customer.&lt;/li&gt;&lt;li&gt;If the parameter importable is set to true, then the csv file will contain only the authorized fields of a CsvGatewayDto.&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v2.2.0&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param fields List of fields to display (optional)
     * @param importable true means that csv is importable from web service createGateways. (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @return ApiResponse&lt;String&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<String> createGatewaysExportWithHttpInfo(String fields, Boolean importable, String search, String sort) throws ApiException {
        com.squareup.okhttp.Call call = createGatewaysExportValidateBeforeCall(fields, importable, search, sort, null, null);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * createGatewaysExport (asynchronously)
     * This web service allows to export the gateways to a CSV file.&lt;br&gt;This web service is asynchronous. It sends a 202 Accepted response status.&lt;br&gt;The response header Content-Location allows to poll the ProgressMonitorDto with the web service getGatewaysExport.&lt;br&gt;The parameters sort and search refer to a GatewayDto.&lt;br&gt;The generated CSV file is a list of CsvGatewayDto.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;li&gt;If the connected user is SUPER_ADMIN then all gateways are exported, otherwise only the gateways attached to his customer.&lt;/li&gt;&lt;li&gt;If the parameter importable is set to true, then the csv file will contain only the authorized fields of a CsvGatewayDto.&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v2.2.0&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param fields List of fields to display (optional)
     * @param importable true means that csv is importable from web service createGateways. (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call createGatewaysExportAsync(String fields, Boolean importable, String search, String sort, final ApiCallback<String> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = createGatewaysExportValidateBeforeCall(fields, importable, search, sort, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for deleteGateway
     * @param eui Gateway EUI (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call deleteGatewayCall(String eui, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/{eui}"
            .replaceAll("\\{" + "eui" + "\\}", apiClient.escapeString(eui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call deleteGatewayValidateBeforeCall(String eui, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'eui' is set
        if (eui == null) {
            throw new ApiException("Missing the required parameter 'eui' when calling deleteGateway(Async)");
        }
        
        com.squareup.okhttp.Call call = deleteGatewayCall(eui, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * deleteGateway
     * This web service allows to delete a gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void deleteGateway(String eui) throws ApiException {
        deleteGatewayWithHttpInfo(eui);
    }

    /**
     * deleteGateway
     * This web service allows to delete a gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> deleteGatewayWithHttpInfo(String eui) throws ApiException {
        com.squareup.okhttp.Call call = deleteGatewayValidateBeforeCall(eui, null, null);
        return apiClient.execute(call);
    }

    /**
     * deleteGateway (asynchronously)
     * This web service allows to delete a gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call deleteGatewayAsync(String eui, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = deleteGatewayValidateBeforeCall(eui, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for deleteLnsGatewayAesKey
     * @param eui Gateway EUI (required)
     * @param index AES key index (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call deleteLnsGatewayAesKeyCall(String eui, Integer index, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/{eui}/aesKeys/{index}"
            .replaceAll("\\{" + "eui" + "\\}", apiClient.escapeString(eui.toString()))
            .replaceAll("\\{" + "index" + "\\}", apiClient.escapeString(index.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call deleteLnsGatewayAesKeyValidateBeforeCall(String eui, Integer index, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'eui' is set
        if (eui == null) {
            throw new ApiException("Missing the required parameter 'eui' when calling deleteLnsGatewayAesKey(Async)");
        }
        // verify the required parameter 'index' is set
        if (index == null) {
            throw new ApiException("Missing the required parameter 'index' when calling deleteLnsGatewayAesKey(Async)");
        }
        
        com.squareup.okhttp.Call call = deleteLnsGatewayAesKeyCall(eui, index, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * deleteLnsGatewayAesKey
     * This web service allows to delete an AES key by index for a gateway.&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param index AES key index (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void deleteLnsGatewayAesKey(String eui, Integer index) throws ApiException {
        deleteLnsGatewayAesKeyWithHttpInfo(eui, index);
    }

    /**
     * deleteLnsGatewayAesKey
     * This web service allows to delete an AES key by index for a gateway.&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param index AES key index (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> deleteLnsGatewayAesKeyWithHttpInfo(String eui, Integer index) throws ApiException {
        com.squareup.okhttp.Call call = deleteLnsGatewayAesKeyValidateBeforeCall(eui, index, null, null);
        return apiClient.execute(call);
    }

    /**
     * deleteLnsGatewayAesKey (asynchronously)
     * This web service allows to delete an AES key by index for a gateway.&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param index AES key index (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call deleteLnsGatewayAesKeyAsync(String eui, Integer index, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = deleteLnsGatewayAesKeyValidateBeforeCall(eui, index, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for getCreateGatewaysStatus
     * @param id Bulk identifier (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getCreateGatewaysStatusCall(String id, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/bulk/{id}"
            .replaceAll("\\{" + "id" + "\\}", apiClient.escapeString(id.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getCreateGatewaysStatusValidateBeforeCall(String id, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling getCreateGatewaysStatus(Async)");
        }
        
        com.squareup.okhttp.Call call = getCreateGatewaysStatusCall(id, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getCreateGatewaysStatus
     * This web service allows to retrieve the progress monitor of the createGateways web service.&lt;br&gt;The ProgressMonitor will be OK if all the unexisted gateways are created correctly. It will be KO if at least one error occurs.&lt;br&gt;If errors occur, the server builds a CSV file wich contains all the lines in error. This file can be retrieved by following the link named csvErrors in the progressMonitorDto.&lt;br&gt;&lt;br&gt;Purge : the monitor is purged 2 days after the last access. If the monitor is never accessed, it will be purged after 2 days.&lt;br&gt;&lt;br&gt;Since: v2.1.0&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param id Bulk identifier (required)
     * @return ProgressMonitorDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ProgressMonitorDto getCreateGatewaysStatus(String id) throws ApiException {
        ApiResponse<ProgressMonitorDto> resp = getCreateGatewaysStatusWithHttpInfo(id);
        return resp.getData();
    }

    /**
     * getCreateGatewaysStatus
     * This web service allows to retrieve the progress monitor of the createGateways web service.&lt;br&gt;The ProgressMonitor will be OK if all the unexisted gateways are created correctly. It will be KO if at least one error occurs.&lt;br&gt;If errors occur, the server builds a CSV file wich contains all the lines in error. This file can be retrieved by following the link named csvErrors in the progressMonitorDto.&lt;br&gt;&lt;br&gt;Purge : the monitor is purged 2 days after the last access. If the monitor is never accessed, it will be purged after 2 days.&lt;br&gt;&lt;br&gt;Since: v2.1.0&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param id Bulk identifier (required)
     * @return ApiResponse&lt;ProgressMonitorDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ProgressMonitorDto> getCreateGatewaysStatusWithHttpInfo(String id) throws ApiException {
        com.squareup.okhttp.Call call = getCreateGatewaysStatusValidateBeforeCall(id, null, null);
        Type localVarReturnType = new TypeToken<ProgressMonitorDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * getCreateGatewaysStatus (asynchronously)
     * This web service allows to retrieve the progress monitor of the createGateways web service.&lt;br&gt;The ProgressMonitor will be OK if all the unexisted gateways are created correctly. It will be KO if at least one error occurs.&lt;br&gt;If errors occur, the server builds a CSV file wich contains all the lines in error. This file can be retrieved by following the link named csvErrors in the progressMonitorDto.&lt;br&gt;&lt;br&gt;Purge : the monitor is purged 2 days after the last access. If the monitor is never accessed, it will be purged after 2 days.&lt;br&gt;&lt;br&gt;Since: v2.1.0&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param id Bulk identifier (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getCreateGatewaysStatusAsync(String id, final ApiCallback<ProgressMonitorDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getCreateGatewaysStatusValidateBeforeCall(id, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ProgressMonitorDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getGateway
     * @param eui Resource extended unique identifier (required)
     * @param fields List of fields to display (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getGatewayCall(String eui, String fields, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/{eui}"
            .replaceAll("\\{" + "eui" + "\\}", apiClient.escapeString(eui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (fields != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fields", fields));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getGatewayValidateBeforeCall(String eui, String fields, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'eui' is set
        if (eui == null) {
            throw new ApiException("Missing the required parameter 'eui' when calling getGateway(Async)");
        }
        
        com.squareup.okhttp.Call call = getGatewayCall(eui, fields, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getGateway
     * This web service allows to retrieve a gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v2.1.0&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Resource extended unique identifier (required)
     * @param fields List of fields to display (optional)
     * @return GatewayDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public GatewayDto getGateway(String eui, String fields) throws ApiException {
        ApiResponse<GatewayDto> resp = getGatewayWithHttpInfo(eui, fields);
        return resp.getData();
    }

    /**
     * getGateway
     * This web service allows to retrieve a gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v2.1.0&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Resource extended unique identifier (required)
     * @param fields List of fields to display (optional)
     * @return ApiResponse&lt;GatewayDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<GatewayDto> getGatewayWithHttpInfo(String eui, String fields) throws ApiException {
        com.squareup.okhttp.Call call = getGatewayValidateBeforeCall(eui, fields, null, null);
        Type localVarReturnType = new TypeToken<GatewayDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * getGateway (asynchronously)
     * This web service allows to retrieve a gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v2.1.0&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Resource extended unique identifier (required)
     * @param fields List of fields to display (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getGatewayAsync(String eui, String fields, final ApiCallback<GatewayDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getGatewayValidateBeforeCall(eui, fields, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<GatewayDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getGatewayConfigurations
     * @param eui Gateway EUI (required)
     * @param fields List of fields to display (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getGatewayConfigurationsCall(String eui, String fields, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/{eui}/configurations"
            .replaceAll("\\{" + "eui" + "\\}", apiClient.escapeString(eui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (fields != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fields", fields));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getGatewayConfigurationsValidateBeforeCall(String eui, String fields, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'eui' is set
        if (eui == null) {
            throw new ApiException("Missing the required parameter 'eui' when calling getGatewayConfigurations(Async)");
        }
        
        com.squareup.okhttp.Call call = getGatewayConfigurationsCall(eui, fields, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getGatewayConfigurations
     * Retrieves the configurations historic of the gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param fields List of fields to display (optional)
     * @return PaginatedDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PaginatedDto<GatewayConfigurationDto> getGatewayConfigurations(String eui, String fields) throws ApiException {
        ApiResponse<PaginatedDto<GatewayConfigurationDto>> resp = getGatewayConfigurationsWithHttpInfo(eui, fields);
        return resp.getData();
    }

    /**
     * getGatewayConfigurations
     * Retrieves the configurations historic of the gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param fields List of fields to display (optional)
     * @return ApiResponse&lt;PaginatedDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PaginatedDto<GatewayConfigurationDto>> getGatewayConfigurationsWithHttpInfo(String eui, String fields) throws ApiException {
        com.squareup.okhttp.Call call = getGatewayConfigurationsValidateBeforeCall(eui, fields, null, null);
        Type localVarReturnType = new TypeToken<PaginatedDto<GatewayConfigurationDto>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * getGatewayConfigurations (asynchronously)
     * Retrieves the configurations historic of the gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param fields List of fields to display (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getGatewayConfigurationsAsync(String eui, String fields, final ApiCallback<PaginatedDto<GatewayConfigurationDto>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getGatewayConfigurationsValidateBeforeCall(eui, fields, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PaginatedDto<GatewayConfigurationDto>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getGatewayConnections
     * @param eui Gateway EUI (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param untilDate Until the date of (EPOCH date in ms), default is current time (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getGatewayConnectionsCall(String eui, String fields, String page, String pageSize, String untilDate, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/{eui}/connections"
            .replaceAll("\\{" + "eui" + "\\}", apiClient.escapeString(eui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (fields != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fields", fields));
        if (page != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("page", page));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("pageSize", pageSize));
        if (untilDate != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("untilDate", untilDate));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getGatewayConnectionsValidateBeforeCall(String eui, String fields, String page, String pageSize, String untilDate, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'eui' is set
        if (eui == null) {
            throw new ApiException("Missing the required parameter 'eui' when calling getGatewayConnections(Async)");
        }
        
        com.squareup.okhttp.Call call = getGatewayConnectionsCall(eui, fields, page, pageSize, untilDate, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getGatewayConnections
     * This web service allows to retrieve the connections of one gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param untilDate Until the date of (EPOCH date in ms), default is current time (optional)
     * @return PaginatedDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PaginatedDto<GatewayConnectionDto> getGatewayConnections(String eui, String fields, String page, String pageSize, String untilDate) throws ApiException {
        ApiResponse<PaginatedDto<GatewayConnectionDto>> resp = getGatewayConnectionsWithHttpInfo(eui, fields, page, pageSize, untilDate);
        return resp.getData();
    }

    /**
     * getGatewayConnections
     * This web service allows to retrieve the connections of one gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param untilDate Until the date of (EPOCH date in ms), default is current time (optional)
     * @return ApiResponse&lt;PaginatedDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PaginatedDto<GatewayConnectionDto>> getGatewayConnectionsWithHttpInfo(String eui, String fields, String page, String pageSize, String untilDate) throws ApiException {
        com.squareup.okhttp.Call call = getGatewayConnectionsValidateBeforeCall(eui, fields, page, pageSize, untilDate, null, null);
        Type localVarReturnType = new TypeToken<PaginatedDto<GatewayConnectionDto>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * getGatewayConnections (asynchronously)
     * This web service allows to retrieve the connections of one gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param untilDate Until the date of (EPOCH date in ms), default is current time (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getGatewayConnectionsAsync(String eui, String fields, String page, String pageSize, String untilDate, final ApiCallback<PaginatedDto<GatewayConnectionDto>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getGatewayConnectionsValidateBeforeCall(eui, fields, page, pageSize, untilDate, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PaginatedDto<GatewayConnectionDto>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getGatewayControl
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param fields List of fields to display for GatewayControlDto (optional)
     * @param groups A comma separated list of GatewayControl groups from predefined set {door, rssi, diskUser, temperature, cpu, diskSystem, gps, ram} (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getGatewayControlCall(String eui, Object criteria, String fields, String groups, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/{eui}/control"
            .replaceAll("\\{" + "eui" + "\\}", apiClient.escapeString(eui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (criteria != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("criteria", criteria));
        if (fields != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fields", fields));
        if (groups != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("groups", groups));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getGatewayControlValidateBeforeCall(String eui, Object criteria, String fields, String groups, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'eui' is set
        if (eui == null) {
            throw new ApiException("Missing the required parameter 'eui' when calling getGatewayControl(Async)");
        }
        
        com.squareup.okhttp.Call call = getGatewayControlCall(eui, criteria, fields, groups, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getGatewayControl
     * This web service allows to retrieve the control data of a gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param fields List of fields to display for GatewayControlDto (optional)
     * @param groups A comma separated list of GatewayControl groups from predefined set {door, rssi, diskUser, temperature, cpu, diskSystem, gps, ram} (optional)
     * @return TaskDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public TaskDto getGatewayControl(String eui, Object criteria, String fields, String groups) throws ApiException {
        ApiResponse<TaskDto> resp = getGatewayControlWithHttpInfo(eui, criteria, fields, groups);
        return resp.getData();
    }

    /**
     * getGatewayControl
     * This web service allows to retrieve the control data of a gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param fields List of fields to display for GatewayControlDto (optional)
     * @param groups A comma separated list of GatewayControl groups from predefined set {door, rssi, diskUser, temperature, cpu, diskSystem, gps, ram} (optional)
     * @return ApiResponse&lt;TaskDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<TaskDto> getGatewayControlWithHttpInfo(String eui, Object criteria, String fields, String groups) throws ApiException {
        com.squareup.okhttp.Call call = getGatewayControlValidateBeforeCall(eui, criteria, fields, groups, null, null);
        Type localVarReturnType = new TypeToken<TaskDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * getGatewayControl (asynchronously)
     * This web service allows to retrieve the control data of a gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param fields List of fields to display for GatewayControlDto (optional)
     * @param groups A comma separated list of GatewayControl groups from predefined set {door, rssi, diskUser, temperature, cpu, diskSystem, gps, ram} (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getGatewayControlAsync(String eui, Object criteria, String fields, String groups, final ApiCallback<TaskDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getGatewayControlValidateBeforeCall(eui, criteria, fields, groups, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<TaskDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getGatewayCurrentConfiguration
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param fields List of fields to display for GatewayConfigurationDto (optional)
     * @param groups A comma separated list of GatewayConfigurationDto groups :  {deviceManagement, wan, vpn, lan, time} (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getGatewayCurrentConfigurationCall(String eui, Object criteria, String fields, String groups, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/{eui}/configurations/current"
            .replaceAll("\\{" + "eui" + "\\}", apiClient.escapeString(eui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (criteria != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("criteria", criteria));
        if (fields != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fields", fields));
        if (groups != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("groups", groups));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getGatewayCurrentConfigurationValidateBeforeCall(String eui, Object criteria, String fields, String groups, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'eui' is set
        if (eui == null) {
            throw new ApiException("Missing the required parameter 'eui' when calling getGatewayCurrentConfiguration(Async)");
        }
        
        com.squareup.okhttp.Call call = getGatewayCurrentConfigurationCall(eui, criteria, fields, groups, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getGatewayCurrentConfiguration
     * This web service allows to retrieve the current configuration of one gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param fields List of fields to display for GatewayConfigurationDto (optional)
     * @param groups A comma separated list of GatewayConfigurationDto groups :  {deviceManagement, wan, vpn, lan, time} (optional)
     * @return TaskDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public TaskDto getGatewayCurrentConfiguration(String eui, Object criteria, String fields, String groups) throws ApiException {
        ApiResponse<TaskDto> resp = getGatewayCurrentConfigurationWithHttpInfo(eui, criteria, fields, groups);
        return resp.getData();
    }

    /**
     * getGatewayCurrentConfiguration
     * This web service allows to retrieve the current configuration of one gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param fields List of fields to display for GatewayConfigurationDto (optional)
     * @param groups A comma separated list of GatewayConfigurationDto groups :  {deviceManagement, wan, vpn, lan, time} (optional)
     * @return ApiResponse&lt;TaskDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<TaskDto> getGatewayCurrentConfigurationWithHttpInfo(String eui, Object criteria, String fields, String groups) throws ApiException {
        com.squareup.okhttp.Call call = getGatewayCurrentConfigurationValidateBeforeCall(eui, criteria, fields, groups, null, null);
        Type localVarReturnType = new TypeToken<TaskDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * getGatewayCurrentConfiguration (asynchronously)
     * This web service allows to retrieve the current configuration of one gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param fields List of fields to display for GatewayConfigurationDto (optional)
     * @param groups A comma separated list of GatewayConfigurationDto groups :  {deviceManagement, wan, vpn, lan, time} (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getGatewayCurrentConfigurationAsync(String eui, Object criteria, String fields, String groups, final ApiCallback<TaskDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getGatewayCurrentConfigurationValidateBeforeCall(eui, criteria, fields, groups, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<TaskDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getGatewayCurrentVersion
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param fields List of fields to display for GatewayVersionDto (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getGatewayCurrentVersionCall(String eui, Object criteria, String fields, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/{eui}/versions/current"
            .replaceAll("\\{" + "eui" + "\\}", apiClient.escapeString(eui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (criteria != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("criteria", criteria));
        if (fields != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fields", fields));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getGatewayCurrentVersionValidateBeforeCall(String eui, Object criteria, String fields, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'eui' is set
        if (eui == null) {
            throw new ApiException("Missing the required parameter 'eui' when calling getGatewayCurrentVersion(Async)");
        }
        
        com.squareup.okhttp.Call call = getGatewayCurrentVersionCall(eui, criteria, fields, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getGatewayCurrentVersion
     * This web service allows to retrieve the current version of one gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param fields List of fields to display for GatewayVersionDto (optional)
     * @return TaskDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public TaskDto getGatewayCurrentVersion(String eui, Object criteria, String fields) throws ApiException {
        ApiResponse<TaskDto> resp = getGatewayCurrentVersionWithHttpInfo(eui, criteria, fields);
        return resp.getData();
    }

    /**
     * getGatewayCurrentVersion
     * This web service allows to retrieve the current version of one gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param fields List of fields to display for GatewayVersionDto (optional)
     * @return ApiResponse&lt;TaskDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<TaskDto> getGatewayCurrentVersionWithHttpInfo(String eui, Object criteria, String fields) throws ApiException {
        com.squareup.okhttp.Call call = getGatewayCurrentVersionValidateBeforeCall(eui, criteria, fields, null, null);
        Type localVarReturnType = new TypeToken<TaskDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * getGatewayCurrentVersion (asynchronously)
     * This web service allows to retrieve the current version of one gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param fields List of fields to display for GatewayVersionDto (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getGatewayCurrentVersionAsync(String eui, Object criteria, String fields, final ApiCallback<TaskDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getGatewayCurrentVersionValidateBeforeCall(eui, criteria, fields, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<TaskDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getGatewayEvents
     * @param endDate The end date of the period (required)
     * @param eui Gateway EUI (required)
     * @param startDate The start date of the period (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param type Event type from predefined set {AUTOMATIC_SYSTEM_RESTORATION, AUTOMATIC_SYSTEM_RESTORATION_FACTORY, CONNECTED, CPU_OFF, CPU_ON, DISCONNECTED, DISK_SYSTEM_OFF, DISK_SYSTEM_ON, DISK_USER_OFF, DISK_USER_ON, DOOR_CLOSED, DOOR_NOT_APPLICABLE, DOOR_OPEN, GPS_LOCKED, GPS_NOT_APPLICABLE, GPS_UNLOCKED, HELLO, POWER_LOST, PREVIOUS_CONFIG_RESTORATION, RAM_OFF, RAM_ON, RESTART, RSSI_OFF, RSSI_ON, SHUTDOWN, SNMP_AUTHENTICATION_FAILURE, START, TEMPERATURE_OFF, TEMPERATURE_ON} (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getGatewayEventsCall(String endDate, String eui, String startDate, String fields, String page, String pageSize, String type, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/{eui}/events"
            .replaceAll("\\{" + "eui" + "\\}", apiClient.escapeString(eui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (endDate != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("endDate", endDate));
        if (fields != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fields", fields));
        if (page != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("page", page));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("pageSize", pageSize));
        if (startDate != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("startDate", startDate));
        if (type != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("type", type));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getGatewayEventsValidateBeforeCall(String endDate, String eui, String startDate, String fields, String page, String pageSize, String type, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'endDate' is set
        if (endDate == null) {
            throw new ApiException("Missing the required parameter 'endDate' when calling getGatewayEvents(Async)");
        }
        // verify the required parameter 'eui' is set
        if (eui == null) {
            throw new ApiException("Missing the required parameter 'eui' when calling getGatewayEvents(Async)");
        }
        // verify the required parameter 'startDate' is set
        if (startDate == null) {
            throw new ApiException("Missing the required parameter 'startDate' when calling getGatewayEvents(Async)");
        }
        
        com.squareup.okhttp.Call call = getGatewayEventsCall(endDate, eui, startDate, fields, page, pageSize, type, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getGatewayEvents
     * This web service allows to retrieve the events attached to one gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param endDate The end date of the period (required)
     * @param eui Gateway EUI (required)
     * @param startDate The start date of the period (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param type Event type from predefined set {AUTOMATIC_SYSTEM_RESTORATION, AUTOMATIC_SYSTEM_RESTORATION_FACTORY, CONNECTED, CPU_OFF, CPU_ON, DISCONNECTED, DISK_SYSTEM_OFF, DISK_SYSTEM_ON, DISK_USER_OFF, DISK_USER_ON, DOOR_CLOSED, DOOR_NOT_APPLICABLE, DOOR_OPEN, GPS_LOCKED, GPS_NOT_APPLICABLE, GPS_UNLOCKED, HELLO, POWER_LOST, PREVIOUS_CONFIG_RESTORATION, RAM_OFF, RAM_ON, RESTART, RSSI_OFF, RSSI_ON, SHUTDOWN, SNMP_AUTHENTICATION_FAILURE, START, TEMPERATURE_OFF, TEMPERATURE_ON} (optional)
     * @return PaginatedDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PaginatedDto<GatewayEventDto> getGatewayEvents(String endDate, String eui, String startDate, String fields, String page, String pageSize, String type) throws ApiException {
        ApiResponse<PaginatedDto<GatewayEventDto>> resp = getGatewayEventsWithHttpInfo(endDate, eui, startDate, fields, page, pageSize, type);
        return resp.getData();
    }

    /**
     * getGatewayEvents
     * This web service allows to retrieve the events attached to one gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param endDate The end date of the period (required)
     * @param eui Gateway EUI (required)
     * @param startDate The start date of the period (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param type Event type from predefined set {AUTOMATIC_SYSTEM_RESTORATION, AUTOMATIC_SYSTEM_RESTORATION_FACTORY, CONNECTED, CPU_OFF, CPU_ON, DISCONNECTED, DISK_SYSTEM_OFF, DISK_SYSTEM_ON, DISK_USER_OFF, DISK_USER_ON, DOOR_CLOSED, DOOR_NOT_APPLICABLE, DOOR_OPEN, GPS_LOCKED, GPS_NOT_APPLICABLE, GPS_UNLOCKED, HELLO, POWER_LOST, PREVIOUS_CONFIG_RESTORATION, RAM_OFF, RAM_ON, RESTART, RSSI_OFF, RSSI_ON, SHUTDOWN, SNMP_AUTHENTICATION_FAILURE, START, TEMPERATURE_OFF, TEMPERATURE_ON} (optional)
     * @return ApiResponse&lt;PaginatedDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PaginatedDto<GatewayEventDto>> getGatewayEventsWithHttpInfo(String endDate, String eui, String startDate, String fields, String page, String pageSize, String type) throws ApiException {
        com.squareup.okhttp.Call call = getGatewayEventsValidateBeforeCall(endDate, eui, startDate, fields, page, pageSize, type, null, null);
        Type localVarReturnType = new TypeToken<PaginatedDto<GatewayEventDto>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * getGatewayEvents (asynchronously)
     * This web service allows to retrieve the events attached to one gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param endDate The end date of the period (required)
     * @param eui Gateway EUI (required)
     * @param startDate The start date of the period (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param type Event type from predefined set {AUTOMATIC_SYSTEM_RESTORATION, AUTOMATIC_SYSTEM_RESTORATION_FACTORY, CONNECTED, CPU_OFF, CPU_ON, DISCONNECTED, DISK_SYSTEM_OFF, DISK_SYSTEM_ON, DISK_USER_OFF, DISK_USER_ON, DOOR_CLOSED, DOOR_NOT_APPLICABLE, DOOR_OPEN, GPS_LOCKED, GPS_NOT_APPLICABLE, GPS_UNLOCKED, HELLO, POWER_LOST, PREVIOUS_CONFIG_RESTORATION, RAM_OFF, RAM_ON, RESTART, RSSI_OFF, RSSI_ON, SHUTDOWN, SNMP_AUTHENTICATION_FAILURE, START, TEMPERATURE_OFF, TEMPERATURE_ON} (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getGatewayEventsAsync(String endDate, String eui, String startDate, String fields, String page, String pageSize, String type, final ApiCallback<PaginatedDto<GatewayEventDto>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getGatewayEventsValidateBeforeCall(endDate, eui, startDate, fields, page, pageSize, type, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PaginatedDto<GatewayEventDto>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getGatewayLastConfiguration
     * @param eui Gateway EUI (required)
     * @param fields List of fields to display (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getGatewayLastConfigurationCall(String eui, String fields, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/{eui}/configurations/last"
            .replaceAll("\\{" + "eui" + "\\}", apiClient.escapeString(eui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (fields != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fields", fields));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getGatewayLastConfigurationValidateBeforeCall(String eui, String fields, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'eui' is set
        if (eui == null) {
            throw new ApiException("Missing the required parameter 'eui' when calling getGatewayLastConfiguration(Async)");
        }
        
        com.squareup.okhttp.Call call = getGatewayLastConfigurationCall(eui, fields, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getGatewayLastConfiguration
     * This web service allows to retrieve the last configuration of one gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param fields List of fields to display (optional)
     * @return GatewayConfigurationDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public GatewayConfigurationDto getGatewayLastConfiguration(String eui, String fields) throws ApiException {
        ApiResponse<GatewayConfigurationDto> resp = getGatewayLastConfigurationWithHttpInfo(eui, fields);
        return resp.getData();
    }

    /**
     * getGatewayLastConfiguration
     * This web service allows to retrieve the last configuration of one gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param fields List of fields to display (optional)
     * @return ApiResponse&lt;GatewayConfigurationDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<GatewayConfigurationDto> getGatewayLastConfigurationWithHttpInfo(String eui, String fields) throws ApiException {
        com.squareup.okhttp.Call call = getGatewayLastConfigurationValidateBeforeCall(eui, fields, null, null);
        Type localVarReturnType = new TypeToken<GatewayConfigurationDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * getGatewayLastConfiguration (asynchronously)
     * This web service allows to retrieve the last configuration of one gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param fields List of fields to display (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getGatewayLastConfigurationAsync(String eui, String fields, final ApiCallback<GatewayConfigurationDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getGatewayLastConfigurationValidateBeforeCall(eui, fields, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<GatewayConfigurationDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getGatewayLastConnection
     * @param eui Gateway EUI (required)
     * @param fields List of fields to display (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getGatewayLastConnectionCall(String eui, String fields, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/{eui}/connections/last"
            .replaceAll("\\{" + "eui" + "\\}", apiClient.escapeString(eui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (fields != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fields", fields));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getGatewayLastConnectionValidateBeforeCall(String eui, String fields, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'eui' is set
        if (eui == null) {
            throw new ApiException("Missing the required parameter 'eui' when calling getGatewayLastConnection(Async)");
        }
        
        com.squareup.okhttp.Call call = getGatewayLastConnectionCall(eui, fields, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getGatewayLastConnection
     * This web service allows to retrieve the last connection of one gateway.&lt;br&gt;For the gateways which have never  been connected, the response body will be empty.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param fields List of fields to display (optional)
     * @return GatewayConnectionDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public GatewayConnectionDto getGatewayLastConnection(String eui, String fields) throws ApiException {
        ApiResponse<GatewayConnectionDto> resp = getGatewayLastConnectionWithHttpInfo(eui, fields);
        return resp.getData();
    }

    /**
     * getGatewayLastConnection
     * This web service allows to retrieve the last connection of one gateway.&lt;br&gt;For the gateways which have never  been connected, the response body will be empty.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param fields List of fields to display (optional)
     * @return ApiResponse&lt;GatewayConnectionDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<GatewayConnectionDto> getGatewayLastConnectionWithHttpInfo(String eui, String fields) throws ApiException {
        com.squareup.okhttp.Call call = getGatewayLastConnectionValidateBeforeCall(eui, fields, null, null);
        Type localVarReturnType = new TypeToken<GatewayConnectionDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * getGatewayLastConnection (asynchronously)
     * This web service allows to retrieve the last connection of one gateway.&lt;br&gt;For the gateways which have never  been connected, the response body will be empty.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param fields List of fields to display (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getGatewayLastConnectionAsync(String eui, String fields, final ApiCallback<GatewayConnectionDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getGatewayLastConnectionValidateBeforeCall(eui, fields, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<GatewayConnectionDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getGatewayLastEvents
     * @param eui Gateway EUI (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getGatewayLastEventsCall(String eui, String fields, String page, String pageSize, String search, String sort, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/{eui}/events/last"
            .replaceAll("\\{" + "eui" + "\\}", apiClient.escapeString(eui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (fields != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fields", fields));
        if (page != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("page", page));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("pageSize", pageSize));
        if (search != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("search", search));
        if (sort != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("sort", sort));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getGatewayLastEventsValidateBeforeCall(String eui, String fields, String page, String pageSize, String search, String sort, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'eui' is set
        if (eui == null) {
            throw new ApiException("Missing the required parameter 'eui' when calling getGatewayLastEvents(Async)");
        }
        
        com.squareup.okhttp.Call call = getGatewayLastEventsCall(eui, fields, page, pageSize, search, sort, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getGatewayLastEvents
     * This web service allows to retrieve the last events attached to a gateway.&lt;br&gt;An event can be an alarm or a notification or both, depends on its value.&lt;br&gt;For example, a disconnection will produce an alarm but a reconnection will produce a notification.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @return PaginatedDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PaginatedDto<LastEventDto> getGatewayLastEvents(String eui, String fields, String page, String pageSize, String search, String sort) throws ApiException {
        ApiResponse<PaginatedDto<LastEventDto>> resp = getGatewayLastEventsWithHttpInfo(eui, fields, page, pageSize, search, sort);
        return resp.getData();
    }

    /**
     * getGatewayLastEvents
     * This web service allows to retrieve the last events attached to a gateway.&lt;br&gt;An event can be an alarm or a notification or both, depends on its value.&lt;br&gt;For example, a disconnection will produce an alarm but a reconnection will produce a notification.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @return ApiResponse&lt;PaginatedDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PaginatedDto<LastEventDto>> getGatewayLastEventsWithHttpInfo(String eui, String fields, String page, String pageSize, String search, String sort) throws ApiException {
        com.squareup.okhttp.Call call = getGatewayLastEventsValidateBeforeCall(eui, fields, page, pageSize, search, sort, null, null);
        Type localVarReturnType = new TypeToken<PaginatedDto<LastEventDto>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * getGatewayLastEvents (asynchronously)
     * This web service allows to retrieve the last events attached to a gateway.&lt;br&gt;An event can be an alarm or a notification or both, depends on its value.&lt;br&gt;For example, a disconnection will produce an alarm but a reconnection will produce a notification.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getGatewayLastEventsAsync(String eui, String fields, String page, String pageSize, String search, String sort, final ApiCallback<PaginatedDto<LastEventDto>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getGatewayLastEventsValidateBeforeCall(eui, fields, page, pageSize, search, sort, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PaginatedDto<LastEventDto>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getGatewayLastOperations
     * @param eui Gateway EUI (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getGatewayLastOperationsCall(String eui, String fields, String page, String pageSize, String search, String sort, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/{eui}/lastOperations"
            .replaceAll("\\{" + "eui" + "\\}", apiClient.escapeString(eui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (fields != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fields", fields));
        if (page != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("page", page));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("pageSize", pageSize));
        if (search != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("search", search));
        if (sort != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("sort", sort));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getGatewayLastOperationsValidateBeforeCall(String eui, String fields, String page, String pageSize, String search, String sort, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'eui' is set
        if (eui == null) {
            throw new ApiException("Missing the required parameter 'eui' when calling getGatewayLastOperations(Async)");
        }
        
        com.squareup.okhttp.Call call = getGatewayLastOperationsCall(eui, fields, page, pageSize, search, sort, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getGatewayLastOperations
     * This web service allows to retrieve the last operations attached to one gateway.&lt;br&gt;An operation is an action done on a gateway (example : command line, get configuration, set control, ....&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @return PaginatedDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PaginatedDto<LastOperationDto> getGatewayLastOperations(String eui, String fields, String page, String pageSize, String search, String sort) throws ApiException {
        ApiResponse<PaginatedDto<LastOperationDto>> resp = getGatewayLastOperationsWithHttpInfo(eui, fields, page, pageSize, search, sort);
        return resp.getData();
    }

    /**
     * getGatewayLastOperations
     * This web service allows to retrieve the last operations attached to one gateway.&lt;br&gt;An operation is an action done on a gateway (example : command line, get configuration, set control, ....&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @return ApiResponse&lt;PaginatedDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PaginatedDto<LastOperationDto>> getGatewayLastOperationsWithHttpInfo(String eui, String fields, String page, String pageSize, String search, String sort) throws ApiException {
        com.squareup.okhttp.Call call = getGatewayLastOperationsValidateBeforeCall(eui, fields, page, pageSize, search, sort, null, null);
        Type localVarReturnType = new TypeToken<PaginatedDto<LastOperationDto>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * getGatewayLastOperations (asynchronously)
     * This web service allows to retrieve the last operations attached to one gateway.&lt;br&gt;An operation is an action done on a gateway (example : command line, get configuration, set control, ....&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getGatewayLastOperationsAsync(String eui, String fields, String page, String pageSize, String search, String sort, final ApiCallback<PaginatedDto<LastOperationDto>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getGatewayLastOperationsValidateBeforeCall(eui, fields, page, pageSize, search, sort, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PaginatedDto<LastOperationDto>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getGatewayLastStatistics
     * @param eui Gateway EUI (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getGatewayLastStatisticsCall(String eui, String fields, String page, String pageSize, String search, String sort, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/{eui}/lastStatistics"
            .replaceAll("\\{" + "eui" + "\\}", apiClient.escapeString(eui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (fields != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fields", fields));
        if (page != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("page", page));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("pageSize", pageSize));
        if (search != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("search", search));
        if (sort != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("sort", sort));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getGatewayLastStatisticsValidateBeforeCall(String eui, String fields, String page, String pageSize, String search, String sort, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'eui' is set
        if (eui == null) {
            throw new ApiException("Missing the required parameter 'eui' when calling getGatewayLastStatistics(Async)");
        }
        
        com.squareup.okhttp.Call call = getGatewayLastStatisticsCall(eui, fields, page, pageSize, search, sort, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getGatewayLastStatistics
     * This web service allows to retrieve the last statistics attached to one gateway.&lt;br&gt;The statisitics consists of counting the number of gateways for which a numeric metric belongs to a range.&lt;br&gt;The statistic of each metric concerns the average value.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @return PaginatedDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PaginatedDto<LastStatisticDto> getGatewayLastStatistics(String eui, String fields, String page, String pageSize, String search, String sort) throws ApiException {
        ApiResponse<PaginatedDto<LastStatisticDto>> resp = getGatewayLastStatisticsWithHttpInfo(eui, fields, page, pageSize, search, sort);
        return resp.getData();
    }

    /**
     * getGatewayLastStatistics
     * This web service allows to retrieve the last statistics attached to one gateway.&lt;br&gt;The statisitics consists of counting the number of gateways for which a numeric metric belongs to a range.&lt;br&gt;The statistic of each metric concerns the average value.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @return ApiResponse&lt;PaginatedDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PaginatedDto<LastStatisticDto>> getGatewayLastStatisticsWithHttpInfo(String eui, String fields, String page, String pageSize, String search, String sort) throws ApiException {
        com.squareup.okhttp.Call call = getGatewayLastStatisticsValidateBeforeCall(eui, fields, page, pageSize, search, sort, null, null);
        Type localVarReturnType = new TypeToken<PaginatedDto<LastStatisticDto>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * getGatewayLastStatistics (asynchronously)
     * This web service allows to retrieve the last statistics attached to one gateway.&lt;br&gt;The statisitics consists of counting the number of gateways for which a numeric metric belongs to a range.&lt;br&gt;The statistic of each metric concerns the average value.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getGatewayLastStatisticsAsync(String eui, String fields, String page, String pageSize, String search, String sort, final ApiCallback<PaginatedDto<LastStatisticDto>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getGatewayLastStatisticsValidateBeforeCall(eui, fields, page, pageSize, search, sort, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PaginatedDto<LastStatisticDto>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getGatewayLastVersion
     * @param eui Gateway EUI (required)
     * @param fields List of fields to display (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getGatewayLastVersionCall(String eui, String fields, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/{eui}/versions/last"
            .replaceAll("\\{" + "eui" + "\\}", apiClient.escapeString(eui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (fields != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fields", fields));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getGatewayLastVersionValidateBeforeCall(String eui, String fields, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'eui' is set
        if (eui == null) {
            throw new ApiException("Missing the required parameter 'eui' when calling getGatewayLastVersion(Async)");
        }
        
        com.squareup.okhttp.Call call = getGatewayLastVersionCall(eui, fields, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getGatewayLastVersion
     * This web service allows to retrieve the last version of one gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param fields List of fields to display (optional)
     * @return GatewayVersionDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public GatewayVersionDto getGatewayLastVersion(String eui, String fields) throws ApiException {
        ApiResponse<GatewayVersionDto> resp = getGatewayLastVersionWithHttpInfo(eui, fields);
        return resp.getData();
    }

    /**
     * getGatewayLastVersion
     * This web service allows to retrieve the last version of one gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param fields List of fields to display (optional)
     * @return ApiResponse&lt;GatewayVersionDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<GatewayVersionDto> getGatewayLastVersionWithHttpInfo(String eui, String fields) throws ApiException {
        com.squareup.okhttp.Call call = getGatewayLastVersionValidateBeforeCall(eui, fields, null, null);
        Type localVarReturnType = new TypeToken<GatewayVersionDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * getGatewayLastVersion (asynchronously)
     * This web service allows to retrieve the last version of one gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param fields List of fields to display (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getGatewayLastVersionAsync(String eui, String fields, final ApiCallback<GatewayVersionDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getGatewayLastVersionValidateBeforeCall(eui, fields, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<GatewayVersionDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getGatewayManagement
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param fields List of fields to display for GatewayManagementDto (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getGatewayManagementCall(String eui, Object criteria, String fields, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/{eui}/management"
            .replaceAll("\\{" + "eui" + "\\}", apiClient.escapeString(eui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (criteria != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("criteria", criteria));
        if (fields != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fields", fields));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getGatewayManagementValidateBeforeCall(String eui, Object criteria, String fields, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'eui' is set
        if (eui == null) {
            throw new ApiException("Missing the required parameter 'eui' when calling getGatewayManagement(Async)");
        }
        
        com.squareup.okhttp.Call call = getGatewayManagementCall(eui, criteria, fields, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getGatewayManagement
     * This web service allows to retrieve the management fields of a gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param fields List of fields to display for GatewayManagementDto (optional)
     * @return TaskDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public TaskDto getGatewayManagement(String eui, Object criteria, String fields) throws ApiException {
        ApiResponse<TaskDto> resp = getGatewayManagementWithHttpInfo(eui, criteria, fields);
        return resp.getData();
    }

    /**
     * getGatewayManagement
     * This web service allows to retrieve the management fields of a gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param fields List of fields to display for GatewayManagementDto (optional)
     * @return ApiResponse&lt;TaskDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<TaskDto> getGatewayManagementWithHttpInfo(String eui, Object criteria, String fields) throws ApiException {
        com.squareup.okhttp.Call call = getGatewayManagementValidateBeforeCall(eui, criteria, fields, null, null);
        Type localVarReturnType = new TypeToken<TaskDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * getGatewayManagement (asynchronously)
     * This web service allows to retrieve the management fields of a gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param fields List of fields to display for GatewayManagementDto (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getGatewayManagementAsync(String eui, Object criteria, String fields, final ApiCallback<TaskDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getGatewayManagementValidateBeforeCall(eui, criteria, fields, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<TaskDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getGatewayModems
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param fields List of fields to display for GatewayModemDto (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getGatewayModemsCall(String eui, Object criteria, String fields, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/{eui}/modems"
            .replaceAll("\\{" + "eui" + "\\}", apiClient.escapeString(eui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (criteria != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("criteria", criteria));
        if (fields != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fields", fields));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getGatewayModemsValidateBeforeCall(String eui, Object criteria, String fields, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'eui' is set
        if (eui == null) {
            throw new ApiException("Missing the required parameter 'eui' when calling getGatewayModems(Async)");
        }
        
        com.squareup.okhttp.Call call = getGatewayModemsCall(eui, criteria, fields, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getGatewayModems
     * This web service allows to retrieve the modems of one gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param fields List of fields to display for GatewayModemDto (optional)
     * @return TaskDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public TaskDto getGatewayModems(String eui, Object criteria, String fields) throws ApiException {
        ApiResponse<TaskDto> resp = getGatewayModemsWithHttpInfo(eui, criteria, fields);
        return resp.getData();
    }

    /**
     * getGatewayModems
     * This web service allows to retrieve the modems of one gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param fields List of fields to display for GatewayModemDto (optional)
     * @return ApiResponse&lt;TaskDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<TaskDto> getGatewayModemsWithHttpInfo(String eui, Object criteria, String fields) throws ApiException {
        com.squareup.okhttp.Call call = getGatewayModemsValidateBeforeCall(eui, criteria, fields, null, null);
        Type localVarReturnType = new TypeToken<TaskDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * getGatewayModems (asynchronously)
     * This web service allows to retrieve the modems of one gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param fields List of fields to display for GatewayModemDto (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getGatewayModemsAsync(String eui, Object criteria, String fields, final ApiCallback<TaskDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getGatewayModemsValidateBeforeCall(eui, criteria, fields, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<TaskDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getGatewayNumericStatistics
     * @param endDate The end date of the period (EPOCH ms). The value must between -9223372036854 and 9223372036854. (required)
     * @param eui Gateway EUI (required)
     * @param startDate The start date of the period (EPOCH ms). The value must between -9223372036854 and 9223372036854. (required)
     * @param temporalUnit The temporal unit  {DAY, HOUR, MONTH, YEAR} (required)
     * @param fields List of fields to display (optional)
     * @param metricNames A comma separated list of metric names. Metric names :  {abortReboot, userDiskUsed, startNumber, gsmMinRssi, ramAvg, gsmAvgRssi, ramMin, cpuThreshold, temperatureMax, sizeDownlinkSum, systemDiskHysteresis, sizeUplinkSum, cpuMax, cpuHysteresis, restartSum, ackrAvg, userDiskHysteresis, systemDiskThreshold, abortCrash, nbDownlinkMessageSum, gpsSatellitesNumber, gsmRssiHysteresis, cpuMin, cpuAvg, gpsLockRatio, nbUplinkMessageSum, extraDiskHysteresis, supplyPowerMilliVolts, ramHysteresis, extraDiskUsed, gsmMaxRssi, temperatureAvg, userDiskThreshold, temperatureMin, systemDiskUsed, temperatureThreshold, extraDiskThreshold, temperatureHysteresis, rxperAvg, ramThreshold, uptimeAvg, ramMax, gsmRssiThreshold, maliciousSshLoginSum} (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getGatewayNumericStatisticsCall(String endDate, String eui, String startDate, String temporalUnit, String fields, String metricNames, String page, String pageSize, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/{eui}/statistics/numeric"
            .replaceAll("\\{" + "eui" + "\\}", apiClient.escapeString(eui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (endDate != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("endDate", endDate));
        if (fields != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fields", fields));
        if (metricNames != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("metricNames", metricNames));
        if (page != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("page", page));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("pageSize", pageSize));
        if (startDate != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("startDate", startDate));
        if (temporalUnit != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("temporalUnit", temporalUnit));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getGatewayNumericStatisticsValidateBeforeCall(String endDate, String eui, String startDate, String temporalUnit, String fields, String metricNames, String page, String pageSize, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'endDate' is set
        if (endDate == null) {
            throw new ApiException("Missing the required parameter 'endDate' when calling getGatewayNumericStatistics(Async)");
        }
        // verify the required parameter 'eui' is set
        if (eui == null) {
            throw new ApiException("Missing the required parameter 'eui' when calling getGatewayNumericStatistics(Async)");
        }
        // verify the required parameter 'startDate' is set
        if (startDate == null) {
            throw new ApiException("Missing the required parameter 'startDate' when calling getGatewayNumericStatistics(Async)");
        }
        // verify the required parameter 'temporalUnit' is set
        if (temporalUnit == null) {
            throw new ApiException("Missing the required parameter 'temporalUnit' when calling getGatewayNumericStatistics(Async)");
        }
        
        com.squareup.okhttp.Call call = getGatewayNumericStatisticsCall(endDate, eui, startDate, temporalUnit, fields, metricNames, page, pageSize, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getGatewayNumericStatistics
     * This web service retrieves the numeric statistics of one gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param endDate The end date of the period (EPOCH ms). The value must between -9223372036854 and 9223372036854. (required)
     * @param eui Gateway EUI (required)
     * @param startDate The start date of the period (EPOCH ms). The value must between -9223372036854 and 9223372036854. (required)
     * @param temporalUnit The temporal unit  {DAY, HOUR, MONTH, YEAR} (required)
     * @param fields List of fields to display (optional)
     * @param metricNames A comma separated list of metric names. Metric names :  {abortReboot, userDiskUsed, startNumber, gsmMinRssi, ramAvg, gsmAvgRssi, ramMin, cpuThreshold, temperatureMax, sizeDownlinkSum, systemDiskHysteresis, sizeUplinkSum, cpuMax, cpuHysteresis, restartSum, ackrAvg, userDiskHysteresis, systemDiskThreshold, abortCrash, nbDownlinkMessageSum, gpsSatellitesNumber, gsmRssiHysteresis, cpuMin, cpuAvg, gpsLockRatio, nbUplinkMessageSum, extraDiskHysteresis, supplyPowerMilliVolts, ramHysteresis, extraDiskUsed, gsmMaxRssi, temperatureAvg, userDiskThreshold, temperatureMin, systemDiskUsed, temperatureThreshold, extraDiskThreshold, temperatureHysteresis, rxperAvg, ramThreshold, uptimeAvg, ramMax, gsmRssiThreshold, maliciousSshLoginSum} (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @return PaginatedDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PaginatedDto<GatewayNumericStatisticsDto> getGatewayNumericStatistics(String endDate, String eui, String startDate, String temporalUnit, String fields, String metricNames, String page, String pageSize) throws ApiException {
        ApiResponse<PaginatedDto<GatewayNumericStatisticsDto>> resp = getGatewayNumericStatisticsWithHttpInfo(endDate, eui, startDate, temporalUnit, fields, metricNames, page, pageSize);
        return resp.getData();
    }

    /**
     * getGatewayNumericStatistics
     * This web service retrieves the numeric statistics of one gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param endDate The end date of the period (EPOCH ms). The value must between -9223372036854 and 9223372036854. (required)
     * @param eui Gateway EUI (required)
     * @param startDate The start date of the period (EPOCH ms). The value must between -9223372036854 and 9223372036854. (required)
     * @param temporalUnit The temporal unit  {DAY, HOUR, MONTH, YEAR} (required)
     * @param fields List of fields to display (optional)
     * @param metricNames A comma separated list of metric names. Metric names :  {abortReboot, userDiskUsed, startNumber, gsmMinRssi, ramAvg, gsmAvgRssi, ramMin, cpuThreshold, temperatureMax, sizeDownlinkSum, systemDiskHysteresis, sizeUplinkSum, cpuMax, cpuHysteresis, restartSum, ackrAvg, userDiskHysteresis, systemDiskThreshold, abortCrash, nbDownlinkMessageSum, gpsSatellitesNumber, gsmRssiHysteresis, cpuMin, cpuAvg, gpsLockRatio, nbUplinkMessageSum, extraDiskHysteresis, supplyPowerMilliVolts, ramHysteresis, extraDiskUsed, gsmMaxRssi, temperatureAvg, userDiskThreshold, temperatureMin, systemDiskUsed, temperatureThreshold, extraDiskThreshold, temperatureHysteresis, rxperAvg, ramThreshold, uptimeAvg, ramMax, gsmRssiThreshold, maliciousSshLoginSum} (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @return ApiResponse&lt;PaginatedDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PaginatedDto<GatewayNumericStatisticsDto>> getGatewayNumericStatisticsWithHttpInfo(String endDate, String eui, String startDate, String temporalUnit, String fields, String metricNames, String page, String pageSize) throws ApiException {
        com.squareup.okhttp.Call call = getGatewayNumericStatisticsValidateBeforeCall(endDate, eui, startDate, temporalUnit, fields, metricNames, page, pageSize, null, null);
        Type localVarReturnType = new TypeToken<PaginatedDto<GatewayNumericStatisticsDto>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * getGatewayNumericStatistics (asynchronously)
     * This web service retrieves the numeric statistics of one gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param endDate The end date of the period (EPOCH ms). The value must between -9223372036854 and 9223372036854. (required)
     * @param eui Gateway EUI (required)
     * @param startDate The start date of the period (EPOCH ms). The value must between -9223372036854 and 9223372036854. (required)
     * @param temporalUnit The temporal unit  {DAY, HOUR, MONTH, YEAR} (required)
     * @param fields List of fields to display (optional)
     * @param metricNames A comma separated list of metric names. Metric names :  {abortReboot, userDiskUsed, startNumber, gsmMinRssi, ramAvg, gsmAvgRssi, ramMin, cpuThreshold, temperatureMax, sizeDownlinkSum, systemDiskHysteresis, sizeUplinkSum, cpuMax, cpuHysteresis, restartSum, ackrAvg, userDiskHysteresis, systemDiskThreshold, abortCrash, nbDownlinkMessageSum, gpsSatellitesNumber, gsmRssiHysteresis, cpuMin, cpuAvg, gpsLockRatio, nbUplinkMessageSum, extraDiskHysteresis, supplyPowerMilliVolts, ramHysteresis, extraDiskUsed, gsmMaxRssi, temperatureAvg, userDiskThreshold, temperatureMin, systemDiskUsed, temperatureThreshold, extraDiskThreshold, temperatureHysteresis, rxperAvg, ramThreshold, uptimeAvg, ramMax, gsmRssiThreshold, maliciousSshLoginSum} (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getGatewayNumericStatisticsAsync(String endDate, String eui, String startDate, String temporalUnit, String fields, String metricNames, String page, String pageSize, final ApiCallback<PaginatedDto<GatewayNumericStatisticsDto>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getGatewayNumericStatisticsValidateBeforeCall(endDate, eui, startDate, temporalUnit, fields, metricNames, page, pageSize, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PaginatedDto<GatewayNumericStatisticsDto>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getGatewaySnmpLogs
     * @param endDate The end date of the period (EPOCH ms) (required)
     * @param eui Gateway EUI (required)
     * @param startDate The start date of the period (EPOCH ms) (required)
     * @param action Action from predefined set {ALARM_CPU, ALARM_DISK_SYSTEM, ALARM_DISK_USER, ALARM_DOOR_EVENT, ALARM_GPS, ALARM_RAM, ALARM_RSSI, ALARM_TEMPERATURE, CONNEXION_CHANGE, FILE_EXCHANGE_ABORT, FILE_EXCHANGE_EXECUTE, FILE_EXCHANGE_STATUS, GATEWAY_DESCRIPTION_CHANGE, GATEWAY_IP_PORT_CHANGE, GET_CONFIGURATION, GET_CONFIGURATIONS, GET_CONTROLS, GET_GATEWAY_DESCRIPTION, GET_HASH_CONFIGURATIONS, GET_HASH_VERSIONS, GET_LAN_MODULES, GET_STATISTIC, GET_STATISTIC_INDEX, GET_VALUES, GET_VERSION, GET_VERSIONS, HELLO, MANAGEMENT_EXECUTE, MANAGEMENT_GET_VALUES, NETWORK_EVENT, NOTIFICATION_AUTHENTICATION_FAILURE, NOTIFICATION_AUTOMATIC_SYSTEM_RESTORATION, NOTIFICATION_AUTOMATIC_SYSTEM_RESTORATION_FACTORY, NOTIFICATION_COLD_START, NOTIFICATION_FILE_EXCHANGE_ABORT, NOTIFICATION_FILE_EXCHANGE_EXECUTE, NOTIFICATION_IP_CHANGE, NOTIFICATION_POWER_LOST, NOTIFICATION_PREVIOUS_CONFIG_RESTORATION, NOTIFICATION_RESTART, NOTIFICATION_SHUTDOWN, NOTIFICATION_SPECIFIC_COMMAND_ABORT, NOTIFICATION_SPECIFIC_COMMAND_EXECUTE, NOTIFICATION_SPECTRUM_ANALYSIS_ABORT, NOTIFICATION_SPECTRUM_ANALYSIS_EXECUTE, NOTIFICATION_START, NOTIFICATION_UPDATE_ABORT, NOTIFICATION_UPDATE_EXECUTE, PING, PING_EVENT, RETURN_KO_STATUS, RETURN_SENDING_STATUS, RETURN_TIMEOUT_STATUS, SET_CONFIGURATION, SET_CONTROLS, SET_VALUES, SIMULATE_ALARM_DOOR_EVENT, SIMULATE_ALARM_GPS_EVENT, SPECIFIC_COMMAND_ABORT, SPECIFIC_COMMAND_EXECUTE, SPECIFIC_COMMAND_STATUS, SPECTRUM_ANALYSIS_ABORT, SPECTRUM_ANALYSIS_EXECUTE, SPECTRUM_ANALYSIS_STATUS, STATISTIC, UPDATE_ABORT, UPDATE_EXECUTE, UPDATE_STATUS} (optional)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param requestId SNMP request identifier (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getGatewaySnmpLogsCall(Long endDate, String eui, Long startDate, String action, String fields, String page, String pageSize, String requestId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/{eui}/snmpLogs"
            .replaceAll("\\{" + "eui" + "\\}", apiClient.escapeString(eui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (action != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("action", action));
        if (endDate != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("endDate", endDate));
        if (fields != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fields", fields));
        if (page != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("page", page));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("pageSize", pageSize));
        if (requestId != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("requestId", requestId));
        if (startDate != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("startDate", startDate));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getGatewaySnmpLogsValidateBeforeCall(Long endDate, String eui, Long startDate, String action, String fields, String page, String pageSize, String requestId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'endDate' is set
        if (endDate == null) {
            throw new ApiException("Missing the required parameter 'endDate' when calling getGatewaySnmpLogs(Async)");
        }
        // verify the required parameter 'eui' is set
        if (eui == null) {
            throw new ApiException("Missing the required parameter 'eui' when calling getGatewaySnmpLogs(Async)");
        }
        // verify the required parameter 'startDate' is set
        if (startDate == null) {
            throw new ApiException("Missing the required parameter 'startDate' when calling getGatewaySnmpLogs(Async)");
        }
        
        com.squareup.okhttp.Call call = getGatewaySnmpLogsCall(endDate, eui, startDate, action, fields, page, pageSize, requestId, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getGatewaySnmpLogs
     * This web service retrieves the SNMP logs of a gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param endDate The end date of the period (EPOCH ms) (required)
     * @param eui Gateway EUI (required)
     * @param startDate The start date of the period (EPOCH ms) (required)
     * @param action Action from predefined set {ALARM_CPU, ALARM_DISK_SYSTEM, ALARM_DISK_USER, ALARM_DOOR_EVENT, ALARM_GPS, ALARM_RAM, ALARM_RSSI, ALARM_TEMPERATURE, CONNEXION_CHANGE, FILE_EXCHANGE_ABORT, FILE_EXCHANGE_EXECUTE, FILE_EXCHANGE_STATUS, GATEWAY_DESCRIPTION_CHANGE, GATEWAY_IP_PORT_CHANGE, GET_CONFIGURATION, GET_CONFIGURATIONS, GET_CONTROLS, GET_GATEWAY_DESCRIPTION, GET_HASH_CONFIGURATIONS, GET_HASH_VERSIONS, GET_LAN_MODULES, GET_STATISTIC, GET_STATISTIC_INDEX, GET_VALUES, GET_VERSION, GET_VERSIONS, HELLO, MANAGEMENT_EXECUTE, MANAGEMENT_GET_VALUES, NETWORK_EVENT, NOTIFICATION_AUTHENTICATION_FAILURE, NOTIFICATION_AUTOMATIC_SYSTEM_RESTORATION, NOTIFICATION_AUTOMATIC_SYSTEM_RESTORATION_FACTORY, NOTIFICATION_COLD_START, NOTIFICATION_FILE_EXCHANGE_ABORT, NOTIFICATION_FILE_EXCHANGE_EXECUTE, NOTIFICATION_IP_CHANGE, NOTIFICATION_POWER_LOST, NOTIFICATION_PREVIOUS_CONFIG_RESTORATION, NOTIFICATION_RESTART, NOTIFICATION_SHUTDOWN, NOTIFICATION_SPECIFIC_COMMAND_ABORT, NOTIFICATION_SPECIFIC_COMMAND_EXECUTE, NOTIFICATION_SPECTRUM_ANALYSIS_ABORT, NOTIFICATION_SPECTRUM_ANALYSIS_EXECUTE, NOTIFICATION_START, NOTIFICATION_UPDATE_ABORT, NOTIFICATION_UPDATE_EXECUTE, PING, PING_EVENT, RETURN_KO_STATUS, RETURN_SENDING_STATUS, RETURN_TIMEOUT_STATUS, SET_CONFIGURATION, SET_CONTROLS, SET_VALUES, SIMULATE_ALARM_DOOR_EVENT, SIMULATE_ALARM_GPS_EVENT, SPECIFIC_COMMAND_ABORT, SPECIFIC_COMMAND_EXECUTE, SPECIFIC_COMMAND_STATUS, SPECTRUM_ANALYSIS_ABORT, SPECTRUM_ANALYSIS_EXECUTE, SPECTRUM_ANALYSIS_STATUS, STATISTIC, UPDATE_ABORT, UPDATE_EXECUTE, UPDATE_STATUS} (optional)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param requestId SNMP request identifier (optional)
     * @return PaginatedDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PaginatedDto<GatewaySnmpLogDto> getGatewaySnmpLogs(Long endDate, String eui, Long startDate, String action, String fields, String page, String pageSize, String requestId) throws ApiException {
        ApiResponse<PaginatedDto<GatewaySnmpLogDto>> resp = getGatewaySnmpLogsWithHttpInfo(endDate, eui, startDate, action, fields, page, pageSize, requestId);
        return resp.getData();
    }

    /**
     * getGatewaySnmpLogs
     * This web service retrieves the SNMP logs of a gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param endDate The end date of the period (EPOCH ms) (required)
     * @param eui Gateway EUI (required)
     * @param startDate The start date of the period (EPOCH ms) (required)
     * @param action Action from predefined set {ALARM_CPU, ALARM_DISK_SYSTEM, ALARM_DISK_USER, ALARM_DOOR_EVENT, ALARM_GPS, ALARM_RAM, ALARM_RSSI, ALARM_TEMPERATURE, CONNEXION_CHANGE, FILE_EXCHANGE_ABORT, FILE_EXCHANGE_EXECUTE, FILE_EXCHANGE_STATUS, GATEWAY_DESCRIPTION_CHANGE, GATEWAY_IP_PORT_CHANGE, GET_CONFIGURATION, GET_CONFIGURATIONS, GET_CONTROLS, GET_GATEWAY_DESCRIPTION, GET_HASH_CONFIGURATIONS, GET_HASH_VERSIONS, GET_LAN_MODULES, GET_STATISTIC, GET_STATISTIC_INDEX, GET_VALUES, GET_VERSION, GET_VERSIONS, HELLO, MANAGEMENT_EXECUTE, MANAGEMENT_GET_VALUES, NETWORK_EVENT, NOTIFICATION_AUTHENTICATION_FAILURE, NOTIFICATION_AUTOMATIC_SYSTEM_RESTORATION, NOTIFICATION_AUTOMATIC_SYSTEM_RESTORATION_FACTORY, NOTIFICATION_COLD_START, NOTIFICATION_FILE_EXCHANGE_ABORT, NOTIFICATION_FILE_EXCHANGE_EXECUTE, NOTIFICATION_IP_CHANGE, NOTIFICATION_POWER_LOST, NOTIFICATION_PREVIOUS_CONFIG_RESTORATION, NOTIFICATION_RESTART, NOTIFICATION_SHUTDOWN, NOTIFICATION_SPECIFIC_COMMAND_ABORT, NOTIFICATION_SPECIFIC_COMMAND_EXECUTE, NOTIFICATION_SPECTRUM_ANALYSIS_ABORT, NOTIFICATION_SPECTRUM_ANALYSIS_EXECUTE, NOTIFICATION_START, NOTIFICATION_UPDATE_ABORT, NOTIFICATION_UPDATE_EXECUTE, PING, PING_EVENT, RETURN_KO_STATUS, RETURN_SENDING_STATUS, RETURN_TIMEOUT_STATUS, SET_CONFIGURATION, SET_CONTROLS, SET_VALUES, SIMULATE_ALARM_DOOR_EVENT, SIMULATE_ALARM_GPS_EVENT, SPECIFIC_COMMAND_ABORT, SPECIFIC_COMMAND_EXECUTE, SPECIFIC_COMMAND_STATUS, SPECTRUM_ANALYSIS_ABORT, SPECTRUM_ANALYSIS_EXECUTE, SPECTRUM_ANALYSIS_STATUS, STATISTIC, UPDATE_ABORT, UPDATE_EXECUTE, UPDATE_STATUS} (optional)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param requestId SNMP request identifier (optional)
     * @return ApiResponse&lt;PaginatedDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PaginatedDto<GatewaySnmpLogDto>> getGatewaySnmpLogsWithHttpInfo(Long endDate, String eui, Long startDate, String action, String fields, String page, String pageSize, String requestId) throws ApiException {
        com.squareup.okhttp.Call call = getGatewaySnmpLogsValidateBeforeCall(endDate, eui, startDate, action, fields, page, pageSize, requestId, null, null);
        Type localVarReturnType = new TypeToken<PaginatedDto<GatewaySnmpLogDto>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * getGatewaySnmpLogs (asynchronously)
     * This web service retrieves the SNMP logs of a gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param endDate The end date of the period (EPOCH ms) (required)
     * @param eui Gateway EUI (required)
     * @param startDate The start date of the period (EPOCH ms) (required)
     * @param action Action from predefined set {ALARM_CPU, ALARM_DISK_SYSTEM, ALARM_DISK_USER, ALARM_DOOR_EVENT, ALARM_GPS, ALARM_RAM, ALARM_RSSI, ALARM_TEMPERATURE, CONNEXION_CHANGE, FILE_EXCHANGE_ABORT, FILE_EXCHANGE_EXECUTE, FILE_EXCHANGE_STATUS, GATEWAY_DESCRIPTION_CHANGE, GATEWAY_IP_PORT_CHANGE, GET_CONFIGURATION, GET_CONFIGURATIONS, GET_CONTROLS, GET_GATEWAY_DESCRIPTION, GET_HASH_CONFIGURATIONS, GET_HASH_VERSIONS, GET_LAN_MODULES, GET_STATISTIC, GET_STATISTIC_INDEX, GET_VALUES, GET_VERSION, GET_VERSIONS, HELLO, MANAGEMENT_EXECUTE, MANAGEMENT_GET_VALUES, NETWORK_EVENT, NOTIFICATION_AUTHENTICATION_FAILURE, NOTIFICATION_AUTOMATIC_SYSTEM_RESTORATION, NOTIFICATION_AUTOMATIC_SYSTEM_RESTORATION_FACTORY, NOTIFICATION_COLD_START, NOTIFICATION_FILE_EXCHANGE_ABORT, NOTIFICATION_FILE_EXCHANGE_EXECUTE, NOTIFICATION_IP_CHANGE, NOTIFICATION_POWER_LOST, NOTIFICATION_PREVIOUS_CONFIG_RESTORATION, NOTIFICATION_RESTART, NOTIFICATION_SHUTDOWN, NOTIFICATION_SPECIFIC_COMMAND_ABORT, NOTIFICATION_SPECIFIC_COMMAND_EXECUTE, NOTIFICATION_SPECTRUM_ANALYSIS_ABORT, NOTIFICATION_SPECTRUM_ANALYSIS_EXECUTE, NOTIFICATION_START, NOTIFICATION_UPDATE_ABORT, NOTIFICATION_UPDATE_EXECUTE, PING, PING_EVENT, RETURN_KO_STATUS, RETURN_SENDING_STATUS, RETURN_TIMEOUT_STATUS, SET_CONFIGURATION, SET_CONTROLS, SET_VALUES, SIMULATE_ALARM_DOOR_EVENT, SIMULATE_ALARM_GPS_EVENT, SPECIFIC_COMMAND_ABORT, SPECIFIC_COMMAND_EXECUTE, SPECIFIC_COMMAND_STATUS, SPECTRUM_ANALYSIS_ABORT, SPECTRUM_ANALYSIS_EXECUTE, SPECTRUM_ANALYSIS_STATUS, STATISTIC, UPDATE_ABORT, UPDATE_EXECUTE, UPDATE_STATUS} (optional)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param requestId SNMP request identifier (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getGatewaySnmpLogsAsync(Long endDate, String eui, Long startDate, String action, String fields, String page, String pageSize, String requestId, final ApiCallback<PaginatedDto<GatewaySnmpLogDto>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getGatewaySnmpLogsValidateBeforeCall(endDate, eui, startDate, action, fields, page, pageSize, requestId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PaginatedDto<GatewaySnmpLogDto>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getGatewayTermStatistics
     * @param endDate The end date of the period (EPOCH ms). The value must between -9223372036854 and 9223372036854. (required)
     * @param eui Gateway EUI (required)
     * @param metricName The metric name  {doorState, gpsStatus, supplyPowerSource, bootCause} (required)
     * @param startDate The start date of the period (EPOCH ms). The value must between -9223372036854 and 9223372036854. (required)
     * @param temporalUnit The temporal unit  {DAY, HOUR, MONTH, YEAR} (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getGatewayTermStatisticsCall(String endDate, String eui, String metricName, String startDate, String temporalUnit, String fields, String page, String pageSize, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/{eui}/statistics/term"
            .replaceAll("\\{" + "eui" + "\\}", apiClient.escapeString(eui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (endDate != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("endDate", endDate));
        if (fields != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fields", fields));
        if (metricName != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("metricName", metricName));
        if (page != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("page", page));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("pageSize", pageSize));
        if (startDate != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("startDate", startDate));
        if (temporalUnit != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("temporalUnit", temporalUnit));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getGatewayTermStatisticsValidateBeforeCall(String endDate, String eui, String metricName, String startDate, String temporalUnit, String fields, String page, String pageSize, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'endDate' is set
        if (endDate == null) {
            throw new ApiException("Missing the required parameter 'endDate' when calling getGatewayTermStatistics(Async)");
        }
        // verify the required parameter 'eui' is set
        if (eui == null) {
            throw new ApiException("Missing the required parameter 'eui' when calling getGatewayTermStatistics(Async)");
        }
        // verify the required parameter 'metricName' is set
        if (metricName == null) {
            throw new ApiException("Missing the required parameter 'metricName' when calling getGatewayTermStatistics(Async)");
        }
        // verify the required parameter 'startDate' is set
        if (startDate == null) {
            throw new ApiException("Missing the required parameter 'startDate' when calling getGatewayTermStatistics(Async)");
        }
        // verify the required parameter 'temporalUnit' is set
        if (temporalUnit == null) {
            throw new ApiException("Missing the required parameter 'temporalUnit' when calling getGatewayTermStatistics(Async)");
        }
        
        com.squareup.okhttp.Call call = getGatewayTermStatisticsCall(endDate, eui, metricName, startDate, temporalUnit, fields, page, pageSize, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getGatewayTermStatistics
     * This web service retrieves the term statistics of one gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param endDate The end date of the period (EPOCH ms). The value must between -9223372036854 and 9223372036854. (required)
     * @param eui Gateway EUI (required)
     * @param metricName The metric name  {doorState, gpsStatus, supplyPowerSource, bootCause} (required)
     * @param startDate The start date of the period (EPOCH ms). The value must between -9223372036854 and 9223372036854. (required)
     * @param temporalUnit The temporal unit  {DAY, HOUR, MONTH, YEAR} (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @return PaginatedDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PaginatedDto<GatewayTermStatisticsDto> getGatewayTermStatistics(String endDate, String eui, String metricName, String startDate, String temporalUnit, String fields, String page, String pageSize) throws ApiException {
        ApiResponse<PaginatedDto<GatewayTermStatisticsDto>> resp = getGatewayTermStatisticsWithHttpInfo(endDate, eui, metricName, startDate, temporalUnit, fields, page, pageSize);
        return resp.getData();
    }

    /**
     * getGatewayTermStatistics
     * This web service retrieves the term statistics of one gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param endDate The end date of the period (EPOCH ms). The value must between -9223372036854 and 9223372036854. (required)
     * @param eui Gateway EUI (required)
     * @param metricName The metric name  {doorState, gpsStatus, supplyPowerSource, bootCause} (required)
     * @param startDate The start date of the period (EPOCH ms). The value must between -9223372036854 and 9223372036854. (required)
     * @param temporalUnit The temporal unit  {DAY, HOUR, MONTH, YEAR} (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @return ApiResponse&lt;PaginatedDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PaginatedDto<GatewayTermStatisticsDto>> getGatewayTermStatisticsWithHttpInfo(String endDate, String eui, String metricName, String startDate, String temporalUnit, String fields, String page, String pageSize) throws ApiException {
        com.squareup.okhttp.Call call = getGatewayTermStatisticsValidateBeforeCall(endDate, eui, metricName, startDate, temporalUnit, fields, page, pageSize, null, null);
        Type localVarReturnType = new TypeToken<PaginatedDto<GatewayTermStatisticsDto>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * getGatewayTermStatistics (asynchronously)
     * This web service retrieves the term statistics of one gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param endDate The end date of the period (EPOCH ms). The value must between -9223372036854 and 9223372036854. (required)
     * @param eui Gateway EUI (required)
     * @param metricName The metric name  {doorState, gpsStatus, supplyPowerSource, bootCause} (required)
     * @param startDate The start date of the period (EPOCH ms). The value must between -9223372036854 and 9223372036854. (required)
     * @param temporalUnit The temporal unit  {DAY, HOUR, MONTH, YEAR} (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getGatewayTermStatisticsAsync(String endDate, String eui, String metricName, String startDate, String temporalUnit, String fields, String page, String pageSize, final ApiCallback<PaginatedDto<GatewayTermStatisticsDto>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getGatewayTermStatisticsValidateBeforeCall(endDate, eui, metricName, startDate, temporalUnit, fields, page, pageSize, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PaginatedDto<GatewayTermStatisticsDto>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getGatewayVersions
     * @param eui Gateway EUI (required)
     * @param fields List of fields to display (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getGatewayVersionsCall(String eui, String fields, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/{eui}/versions"
            .replaceAll("\\{" + "eui" + "\\}", apiClient.escapeString(eui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (fields != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fields", fields));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getGatewayVersionsValidateBeforeCall(String eui, String fields, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'eui' is set
        if (eui == null) {
            throw new ApiException("Missing the required parameter 'eui' when calling getGatewayVersions(Async)");
        }
        
        com.squareup.okhttp.Call call = getGatewayVersionsCall(eui, fields, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getGatewayVersions
     * This web service allows to retrieve the versions of one gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param fields List of fields to display (optional)
     * @return PaginatedDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PaginatedDto<GatewayVersionDto> getGatewayVersions(String eui, String fields) throws ApiException {
        ApiResponse<PaginatedDto<GatewayVersionDto>> resp = getGatewayVersionsWithHttpInfo(eui, fields);
        return resp.getData();
    }

    /**
     * getGatewayVersions
     * This web service allows to retrieve the versions of one gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param fields List of fields to display (optional)
     * @return ApiResponse&lt;PaginatedDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PaginatedDto<GatewayVersionDto>> getGatewayVersionsWithHttpInfo(String eui, String fields) throws ApiException {
        com.squareup.okhttp.Call call = getGatewayVersionsValidateBeforeCall(eui, fields, null, null);
        Type localVarReturnType = new TypeToken<PaginatedDto<GatewayVersionDto>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * getGatewayVersions (asynchronously)
     * This web service allows to retrieve the versions of one gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param fields List of fields to display (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getGatewayVersionsAsync(String eui, String fields, final ApiCallback<PaginatedDto<GatewayVersionDto>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getGatewayVersionsValidateBeforeCall(eui, fields, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PaginatedDto<GatewayVersionDto>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getGateways
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getGatewaysCall(String fields, String page, String pageSize, String search, String sort, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (fields != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fields", fields));
        if (page != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("page", page));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("pageSize", pageSize));
        if (search != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("search", search));
        if (sort != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("sort", sort));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getGatewaysValidateBeforeCall(String fields, String page, String pageSize, String search, String sort, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        com.squareup.okhttp.Call call = getGatewaysCall(fields, page, pageSize, search, sort, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getGateways
     * This web service allows to get the list of gateways.If the authenticated user is SUPER_ADMIN all the gateways are returned, otherwise only the gateways attached to the customer of the authenticated user are returned.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @return PaginatedDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PaginatedDto<GatewayDto> getGateways(String fields, String page, String pageSize, String search, String sort) throws ApiException {
        ApiResponse<PaginatedDto<GatewayDto>> resp = getGatewaysWithHttpInfo(fields, page, pageSize, search, sort);
        return resp.getData();
    }

    /**
     * getGateways
     * This web service allows to get the list of gateways.If the authenticated user is SUPER_ADMIN all the gateways are returned, otherwise only the gateways attached to the customer of the authenticated user are returned.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @return ApiResponse&lt;PaginatedDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PaginatedDto<GatewayDto>> getGatewaysWithHttpInfo(String fields, String page, String pageSize, String search, String sort) throws ApiException {
        com.squareup.okhttp.Call call = getGatewaysValidateBeforeCall(fields, page, pageSize, search, sort, null, null);
        Type localVarReturnType = new TypeToken<PaginatedDto<GatewayDto>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * getGateways (asynchronously)
     * This web service allows to get the list of gateways.If the authenticated user is SUPER_ADMIN all the gateways are returned, otherwise only the gateways attached to the customer of the authenticated user are returned.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getGatewaysAsync(String fields, String page, String pageSize, String search, String sort, final ApiCallback<PaginatedDto<GatewayDto>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getGatewaysValidateBeforeCall(fields, page, pageSize, search, sort, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PaginatedDto<GatewayDto>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getGatewaysDeletion
     * @param id Deletion identifier (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getGatewaysDeletionCall(String id, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/deletions/{id}"
            .replaceAll("\\{" + "id" + "\\}", apiClient.escapeString(id.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getGatewaysDeletionValidateBeforeCall(String id, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling getGatewaysDeletion(Async)");
        }
        
        com.squareup.okhttp.Call call = getGatewaysDeletionCall(id, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getGatewaysDeletion
     * This web service allows to retrieve the progress monitor of a gateways deletion.&lt;br&gt;&lt;br&gt;Purge : the monitor is purged 2 days after the last access. If the monitor is never accessed, it will be purged after 2 days.&lt;br&gt;&lt;br&gt;Since: v2.2.0&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param id Deletion identifier (required)
     * @return ProgressMonitorDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ProgressMonitorDto getGatewaysDeletion(String id) throws ApiException {
        ApiResponse<ProgressMonitorDto> resp = getGatewaysDeletionWithHttpInfo(id);
        return resp.getData();
    }

    /**
     * getGatewaysDeletion
     * This web service allows to retrieve the progress monitor of a gateways deletion.&lt;br&gt;&lt;br&gt;Purge : the monitor is purged 2 days after the last access. If the monitor is never accessed, it will be purged after 2 days.&lt;br&gt;&lt;br&gt;Since: v2.2.0&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param id Deletion identifier (required)
     * @return ApiResponse&lt;ProgressMonitorDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ProgressMonitorDto> getGatewaysDeletionWithHttpInfo(String id) throws ApiException {
        com.squareup.okhttp.Call call = getGatewaysDeletionValidateBeforeCall(id, null, null);
        Type localVarReturnType = new TypeToken<ProgressMonitorDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * getGatewaysDeletion (asynchronously)
     * This web service allows to retrieve the progress monitor of a gateways deletion.&lt;br&gt;&lt;br&gt;Purge : the monitor is purged 2 days after the last access. If the monitor is never accessed, it will be purged after 2 days.&lt;br&gt;&lt;br&gt;Since: v2.2.0&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param id Deletion identifier (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getGatewaysDeletionAsync(String id, final ApiCallback<ProgressMonitorDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getGatewaysDeletionValidateBeforeCall(id, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ProgressMonitorDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getGatewaysExport
     * @param id Resource identifier (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getGatewaysExportCall(String id, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/exports/{id}"
            .replaceAll("\\{" + "id" + "\\}", apiClient.escapeString(id.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getGatewaysExportValidateBeforeCall(String id, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling getGatewaysExport(Async)");
        }
        
        com.squareup.okhttp.Call call = getGatewaysExportCall(id, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getGatewaysExport
     * This web service allows to get the progress monitor of the gateways export web service (createGatewaysExport).&lt;br&gt;When the progress monitor is terminated, one or two links are created depending on the status:&lt;br&gt;- Link with a rel field called success for the successfuly exported gatways&lt;br&gt;- Link with a rel field called failed for the exported gateways with errors&lt;br&gt;Purge: The monitor is purged 2 days after the last access. If the monitor is never accessed, it will be purged after 2 days.&lt;br&gt;&lt;br&gt;Since: v2.2.0&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param id Resource identifier (required)
     * @return ProgressMonitorDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ProgressMonitorDto getGatewaysExport(String id) throws ApiException {
        ApiResponse<ProgressMonitorDto> resp = getGatewaysExportWithHttpInfo(id);
        return resp.getData();
    }

    /**
     * getGatewaysExport
     * This web service allows to get the progress monitor of the gateways export web service (createGatewaysExport).&lt;br&gt;When the progress monitor is terminated, one or two links are created depending on the status:&lt;br&gt;- Link with a rel field called success for the successfuly exported gatways&lt;br&gt;- Link with a rel field called failed for the exported gateways with errors&lt;br&gt;Purge: The monitor is purged 2 days after the last access. If the monitor is never accessed, it will be purged after 2 days.&lt;br&gt;&lt;br&gt;Since: v2.2.0&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param id Resource identifier (required)
     * @return ApiResponse&lt;ProgressMonitorDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ProgressMonitorDto> getGatewaysExportWithHttpInfo(String id) throws ApiException {
        com.squareup.okhttp.Call call = getGatewaysExportValidateBeforeCall(id, null, null);
        Type localVarReturnType = new TypeToken<ProgressMonitorDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * getGatewaysExport (asynchronously)
     * This web service allows to get the progress monitor of the gateways export web service (createGatewaysExport).&lt;br&gt;When the progress monitor is terminated, one or two links are created depending on the status:&lt;br&gt;- Link with a rel field called success for the successfuly exported gatways&lt;br&gt;- Link with a rel field called failed for the exported gateways with errors&lt;br&gt;Purge: The monitor is purged 2 days after the last access. If the monitor is never accessed, it will be purged after 2 days.&lt;br&gt;&lt;br&gt;Since: v2.2.0&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param id Resource identifier (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getGatewaysExportAsync(String id, final ApiCallback<ProgressMonitorDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getGatewaysExportValidateBeforeCall(id, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ProgressMonitorDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getLastGatewayStatistics
     * @param eui Gateway EUI (required)
     * @param fields List of fields to display (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getLastGatewayStatisticsCall(String eui, String fields, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/{eui}/statistics/last"
            .replaceAll("\\{" + "eui" + "\\}", apiClient.escapeString(eui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (fields != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fields", fields));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getLastGatewayStatisticsValidateBeforeCall(String eui, String fields, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'eui' is set
        if (eui == null) {
            throw new ApiException("Missing the required parameter 'eui' when calling getLastGatewayStatistics(Async)");
        }
        
        com.squareup.okhttp.Call call = getLastGatewayStatisticsCall(eui, fields, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getLastGatewayStatistics
     * This web service retrieves the last statistics of one gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param fields List of fields to display (optional)
     * @return GatewayStatisticsDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public GatewayStatisticsDto getLastGatewayStatistics(String eui, String fields) throws ApiException {
        ApiResponse<GatewayStatisticsDto> resp = getLastGatewayStatisticsWithHttpInfo(eui, fields);
        return resp.getData();
    }

    /**
     * getLastGatewayStatistics
     * This web service retrieves the last statistics of one gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param fields List of fields to display (optional)
     * @return ApiResponse&lt;GatewayStatisticsDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<GatewayStatisticsDto> getLastGatewayStatisticsWithHttpInfo(String eui, String fields) throws ApiException {
        com.squareup.okhttp.Call call = getLastGatewayStatisticsValidateBeforeCall(eui, fields, null, null);
        Type localVarReturnType = new TypeToken<GatewayStatisticsDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * getLastGatewayStatistics (asynchronously)
     * This web service retrieves the last statistics of one gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param fields List of fields to display (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getLastGatewayStatisticsAsync(String eui, String fields, final ApiCallback<GatewayStatisticsDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getLastGatewayStatisticsValidateBeforeCall(eui, fields, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<GatewayStatisticsDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getModemStatistics
     * @param endDate The end date of the period (EPOCH ms) (required)
     * @param eui Gateway EUI (required)
     * @param serialNumber Modem serial number (required)
     * @param startDate The start date of the period (EPOCH ms) (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getModemStatisticsCall(String endDate, String eui, String serialNumber, String startDate, String fields, String page, String pageSize, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/{eui}/modems/{serialNumber}/statistics"
            .replaceAll("\\{" + "eui" + "\\}", apiClient.escapeString(eui.toString()))
            .replaceAll("\\{" + "serialNumber" + "\\}", apiClient.escapeString(serialNumber.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (endDate != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("endDate", endDate));
        if (fields != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fields", fields));
        if (page != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("page", page));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("pageSize", pageSize));
        if (startDate != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("startDate", startDate));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getModemStatisticsValidateBeforeCall(String endDate, String eui, String serialNumber, String startDate, String fields, String page, String pageSize, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'endDate' is set
        if (endDate == null) {
            throw new ApiException("Missing the required parameter 'endDate' when calling getModemStatistics(Async)");
        }
        // verify the required parameter 'eui' is set
        if (eui == null) {
            throw new ApiException("Missing the required parameter 'eui' when calling getModemStatistics(Async)");
        }
        // verify the required parameter 'serialNumber' is set
        if (serialNumber == null) {
            throw new ApiException("Missing the required parameter 'serialNumber' when calling getModemStatistics(Async)");
        }
        // verify the required parameter 'startDate' is set
        if (startDate == null) {
            throw new ApiException("Missing the required parameter 'startDate' when calling getModemStatistics(Async)");
        }
        
        com.squareup.okhttp.Call call = getModemStatisticsCall(endDate, eui, serialNumber, startDate, fields, page, pageSize, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getModemStatistics
     * This web service retrieves the statistics of one modem.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param endDate The end date of the period (EPOCH ms) (required)
     * @param eui Gateway EUI (required)
     * @param serialNumber Modem serial number (required)
     * @param startDate The start date of the period (EPOCH ms) (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @return PaginatedDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PaginatedDto<GatewayModemStatisticDto> getModemStatistics(String endDate, String eui, String serialNumber, String startDate, String fields, String page, String pageSize) throws ApiException {
        ApiResponse<PaginatedDto<GatewayModemStatisticDto>> resp = getModemStatisticsWithHttpInfo(endDate, eui, serialNumber, startDate, fields, page, pageSize);
        return resp.getData();
    }

    /**
     * getModemStatistics
     * This web service retrieves the statistics of one modem.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param endDate The end date of the period (EPOCH ms) (required)
     * @param eui Gateway EUI (required)
     * @param serialNumber Modem serial number (required)
     * @param startDate The start date of the period (EPOCH ms) (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @return ApiResponse&lt;PaginatedDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PaginatedDto<GatewayModemStatisticDto>> getModemStatisticsWithHttpInfo(String endDate, String eui, String serialNumber, String startDate, String fields, String page, String pageSize) throws ApiException {
        com.squareup.okhttp.Call call = getModemStatisticsValidateBeforeCall(endDate, eui, serialNumber, startDate, fields, page, pageSize, null, null);
        Type localVarReturnType = new TypeToken<PaginatedDto<GatewayModemStatisticDto>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * getModemStatistics (asynchronously)
     * This web service retrieves the statistics of one modem.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param endDate The end date of the period (EPOCH ms) (required)
     * @param eui Gateway EUI (required)
     * @param serialNumber Modem serial number (required)
     * @param startDate The start date of the period (EPOCH ms) (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getModemStatisticsAsync(String endDate, String eui, String serialNumber, String startDate, String fields, String page, String pageSize, final ApiCallback<PaginatedDto<GatewayModemStatisticDto>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getModemStatisticsValidateBeforeCall(endDate, eui, serialNumber, startDate, fields, page, pageSize, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PaginatedDto<GatewayModemStatisticDto>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getRncCustomerGatewayKpi
     * @param eui Gateway EUI (required)
     * @param kpi Kpi identifier from predefined set {DOWNLINK_BYTES, NB_DOWNLINK, NB_END_DEVICE, NB_UPLINK, PING, RSSI_UPLINK_MESSAGE, SNR_UPLINK_MESSAGE, TOA_DOWNLINK_MESSAGE, TOA_UPLINK_MESSAGE, UPLINK_BYTES} (required)
     * @param period Aggregation period from predefined set {DAY, HOUR, MINUTE, MONTH, WEEK, YEAR} (required)
     * @param activationType For kpi&#x3D;NB_END_DEVICE only Predefined set {ABP, OTAA} (optional)
     * @param frq For kpi&#x3D;TOA_DOWNLINK_MESSAGE only (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param sf For kpi&#x3D;TOA_DOWNLINK_MESSAGE only (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getRncCustomerGatewayKpiCall(String eui, String kpi, String period, String activationType, String frq, String page, String pageSize, String sf, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/{eui}/kpis/{kpi}"
            .replaceAll("\\{" + "eui" + "\\}", apiClient.escapeString(eui.toString()))
            .replaceAll("\\{" + "kpi" + "\\}", apiClient.escapeString(kpi.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (activationType != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("activationType", activationType));
        if (frq != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("frq", frq));
        if (page != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("page", page));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("pageSize", pageSize));
        if (period != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("period", period));
        if (sf != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("sf", sf));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getRncCustomerGatewayKpiValidateBeforeCall(String eui, String kpi, String period, String activationType, String frq, String page, String pageSize, String sf, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'eui' is set
        if (eui == null) {
            throw new ApiException("Missing the required parameter 'eui' when calling getRncCustomerGatewayKpi(Async)");
        }
        // verify the required parameter 'kpi' is set
        if (kpi == null) {
            throw new ApiException("Missing the required parameter 'kpi' when calling getRncCustomerGatewayKpi(Async)");
        }
        // verify the required parameter 'period' is set
        if (period == null) {
            throw new ApiException("Missing the required parameter 'period' when calling getRncCustomerGatewayKpi(Async)");
        }
        
        com.squareup.okhttp.Call call = getRncCustomerGatewayKpiCall(eui, kpi, period, activationType, frq, page, pageSize, sf, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getRncCustomerGatewayKpi
     * This web service returns a KPI by customer and gateway for one gateway.&lt;br&gt;KPI : {DOWNLINK_BYTES, NB_DOWNLINK, NB_END_DEVICE, NB_UPLINK, PING, RSSI_UPLINK_MESSAGE, SNR_UPLINK_MESSAGE, TOA_DOWNLINK_MESSAGE, TOA_UPLINK_MESSAGE, UPLINK_BYTES}period : {DAY, HOUR, MINUTE, MONTH, WEEK, YEAR}&lt;br&gt;&lt;br&gt;Since: v3.0.0&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param kpi Kpi identifier from predefined set {DOWNLINK_BYTES, NB_DOWNLINK, NB_END_DEVICE, NB_UPLINK, PING, RSSI_UPLINK_MESSAGE, SNR_UPLINK_MESSAGE, TOA_DOWNLINK_MESSAGE, TOA_UPLINK_MESSAGE, UPLINK_BYTES} (required)
     * @param period Aggregation period from predefined set {DAY, HOUR, MINUTE, MONTH, WEEK, YEAR} (required)
     * @param activationType For kpi&#x3D;NB_END_DEVICE only Predefined set {ABP, OTAA} (optional)
     * @param frq For kpi&#x3D;TOA_DOWNLINK_MESSAGE only (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param sf For kpi&#x3D;TOA_DOWNLINK_MESSAGE only (optional)
     * @return PaginatedDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PaginatedDto<KpiDto> getRncCustomerGatewayKpi(String eui, String kpi, String period, String activationType, String frq, String page, String pageSize, String sf) throws ApiException {
        ApiResponse<PaginatedDto<KpiDto>> resp = getRncCustomerGatewayKpiWithHttpInfo(eui, kpi, period, activationType, frq, page, pageSize, sf);
        return resp.getData();
    }

    /**
     * getRncCustomerGatewayKpi
     * This web service returns a KPI by customer and gateway for one gateway.&lt;br&gt;KPI : {DOWNLINK_BYTES, NB_DOWNLINK, NB_END_DEVICE, NB_UPLINK, PING, RSSI_UPLINK_MESSAGE, SNR_UPLINK_MESSAGE, TOA_DOWNLINK_MESSAGE, TOA_UPLINK_MESSAGE, UPLINK_BYTES}period : {DAY, HOUR, MINUTE, MONTH, WEEK, YEAR}&lt;br&gt;&lt;br&gt;Since: v3.0.0&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param kpi Kpi identifier from predefined set {DOWNLINK_BYTES, NB_DOWNLINK, NB_END_DEVICE, NB_UPLINK, PING, RSSI_UPLINK_MESSAGE, SNR_UPLINK_MESSAGE, TOA_DOWNLINK_MESSAGE, TOA_UPLINK_MESSAGE, UPLINK_BYTES} (required)
     * @param period Aggregation period from predefined set {DAY, HOUR, MINUTE, MONTH, WEEK, YEAR} (required)
     * @param activationType For kpi&#x3D;NB_END_DEVICE only Predefined set {ABP, OTAA} (optional)
     * @param frq For kpi&#x3D;TOA_DOWNLINK_MESSAGE only (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param sf For kpi&#x3D;TOA_DOWNLINK_MESSAGE only (optional)
     * @return ApiResponse&lt;PaginatedDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PaginatedDto<KpiDto>> getRncCustomerGatewayKpiWithHttpInfo(String eui, String kpi, String period, String activationType, String frq, String page, String pageSize, String sf) throws ApiException {
        com.squareup.okhttp.Call call = getRncCustomerGatewayKpiValidateBeforeCall(eui, kpi, period, activationType, frq, page, pageSize, sf, null, null);
        Type localVarReturnType = new TypeToken<PaginatedDto<KpiDto>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * getRncCustomerGatewayKpi (asynchronously)
     * This web service returns a KPI by customer and gateway for one gateway.&lt;br&gt;KPI : {DOWNLINK_BYTES, NB_DOWNLINK, NB_END_DEVICE, NB_UPLINK, PING, RSSI_UPLINK_MESSAGE, SNR_UPLINK_MESSAGE, TOA_DOWNLINK_MESSAGE, TOA_UPLINK_MESSAGE, UPLINK_BYTES}period : {DAY, HOUR, MINUTE, MONTH, WEEK, YEAR}&lt;br&gt;&lt;br&gt;Since: v3.0.0&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param eui Gateway EUI (required)
     * @param kpi Kpi identifier from predefined set {DOWNLINK_BYTES, NB_DOWNLINK, NB_END_DEVICE, NB_UPLINK, PING, RSSI_UPLINK_MESSAGE, SNR_UPLINK_MESSAGE, TOA_DOWNLINK_MESSAGE, TOA_UPLINK_MESSAGE, UPLINK_BYTES} (required)
     * @param period Aggregation period from predefined set {DAY, HOUR, MINUTE, MONTH, WEEK, YEAR} (required)
     * @param activationType For kpi&#x3D;NB_END_DEVICE only Predefined set {ABP, OTAA} (optional)
     * @param frq For kpi&#x3D;TOA_DOWNLINK_MESSAGE only (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param sf For kpi&#x3D;TOA_DOWNLINK_MESSAGE only (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getRncCustomerGatewayKpiAsync(String eui, String kpi, String period, String activationType, String frq, String page, String pageSize, String sf, final ApiCallback<PaginatedDto<KpiDto>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getRncCustomerGatewayKpiValidateBeforeCall(eui, kpi, period, activationType, frq, page, pageSize, sf, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PaginatedDto<KpiDto>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for patchGateway
     * @param body The DTO JSON representation to put in the request body (required)
     * @param eui Resource extended unique identifier (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call patchGatewayCall(GatewayDto body, String eui, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/{eui}"
            .replaceAll("\\{" + "eui" + "\\}", apiClient.escapeString(eui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "PATCH", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call patchGatewayValidateBeforeCall(GatewayDto body, String eui, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling patchGateway(Async)");
        }
        // verify the required parameter 'eui' is set
        if (eui == null) {
            throw new ApiException("Missing the required parameter 'eui' when calling patchGateway(Async)");
        }
        
        com.squareup.okhttp.Call call = patchGatewayCall(body, eui, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * patchGateway
     * This web service allows to patch a gateway.&lt;br&gt;It also allows to move the gateway to another fleet by defining the id field of the fleet object.If the customer has changed, the maximum number of gateways cannot be exceeded.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;li&gt;The fields {allowGPSPosition, maxTxPower, networkMaxDelayDown, networkMaxDelayUp} are updated if the user is at least ADMIN.&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param body The DTO JSON representation to put in the request body (required)
     * @param eui Resource extended unique identifier (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void patchGateway(GatewayDto body, String eui) throws ApiException {
        patchGatewayWithHttpInfo(body, eui);
    }

    /**
     * patchGateway
     * This web service allows to patch a gateway.&lt;br&gt;It also allows to move the gateway to another fleet by defining the id field of the fleet object.If the customer has changed, the maximum number of gateways cannot be exceeded.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;li&gt;The fields {allowGPSPosition, maxTxPower, networkMaxDelayDown, networkMaxDelayUp} are updated if the user is at least ADMIN.&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param body The DTO JSON representation to put in the request body (required)
     * @param eui Resource extended unique identifier (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> patchGatewayWithHttpInfo(GatewayDto body, String eui) throws ApiException {
        com.squareup.okhttp.Call call = patchGatewayValidateBeforeCall(body, eui, null, null);
        return apiClient.execute(call);
    }

    /**
     * patchGateway (asynchronously)
     * This web service allows to patch a gateway.&lt;br&gt;It also allows to move the gateway to another fleet by defining the id field of the fleet object.If the customer has changed, the maximum number of gateways cannot be exceeded.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;li&gt;The fields {allowGPSPosition, maxTxPower, networkMaxDelayDown, networkMaxDelayUp} are updated if the user is at least ADMIN.&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param body The DTO JSON representation to put in the request body (required)
     * @param eui Resource extended unique identifier (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call patchGatewayAsync(GatewayDto body, String eui, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = patchGatewayValidateBeforeCall(body, eui, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for putLnsGatewayAesKey
     * @param body The DTO JSON representation to put in the request body (required)
     * @param eui Gateway EUI (required)
     * @param index AES key index (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call putLnsGatewayAesKeyCall(LnsGatewayKeyDto body, String eui, Integer index, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/{eui}/aesKeys/{index}"
            .replaceAll("\\{" + "eui" + "\\}", apiClient.escapeString(eui.toString()))
            .replaceAll("\\{" + "index" + "\\}", apiClient.escapeString(index.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call putLnsGatewayAesKeyValidateBeforeCall(LnsGatewayKeyDto body, String eui, Integer index, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling putLnsGatewayAesKey(Async)");
        }
        // verify the required parameter 'eui' is set
        if (eui == null) {
            throw new ApiException("Missing the required parameter 'eui' when calling putLnsGatewayAesKey(Async)");
        }
        // verify the required parameter 'index' is set
        if (index == null) {
            throw new ApiException("Missing the required parameter 'index' when calling putLnsGatewayAesKey(Async)");
        }
        
        com.squareup.okhttp.Call call = putLnsGatewayAesKeyCall(body, eui, index, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * putLnsGatewayAesKey
     * This web service allows to set a new AES key for a gateway used for fine timestamp decryption.&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param body The DTO JSON representation to put in the request body (required)
     * @param eui Gateway EUI (required)
     * @param index AES key index (required)
     * @return String
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public String putLnsGatewayAesKey(LnsGatewayKeyDto body, String eui, Integer index) throws ApiException {
        ApiResponse<String> resp = putLnsGatewayAesKeyWithHttpInfo(body, eui, index);
        return resp.getData();
    }

    /**
     * putLnsGatewayAesKey
     * This web service allows to set a new AES key for a gateway used for fine timestamp decryption.&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param body The DTO JSON representation to put in the request body (required)
     * @param eui Gateway EUI (required)
     * @param index AES key index (required)
     * @return ApiResponse&lt;String&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<String> putLnsGatewayAesKeyWithHttpInfo(LnsGatewayKeyDto body, String eui, Integer index) throws ApiException {
        com.squareup.okhttp.Call call = putLnsGatewayAesKeyValidateBeforeCall(body, eui, index, null, null);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * putLnsGatewayAesKey (asynchronously)
     * This web service allows to set a new AES key for a gateway used for fine timestamp decryption.&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param body The DTO JSON representation to put in the request body (required)
     * @param eui Gateway EUI (required)
     * @param index AES key index (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call putLnsGatewayAesKeyAsync(LnsGatewayKeyDto body, String eui, Integer index, final ApiCallback<String> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = putLnsGatewayAesKeyValidateBeforeCall(body, eui, index, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for updateGatewayControl
     * @param body The DTO JSON representation to put in the request body (required)
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call updateGatewayControlCall(GatewayControlDto body, String eui, Object criteria, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/{eui}/control"
            .replaceAll("\\{" + "eui" + "\\}", apiClient.escapeString(eui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (criteria != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("criteria", criteria));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "PATCH", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call updateGatewayControlValidateBeforeCall(GatewayControlDto body, String eui, Object criteria, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling updateGatewayControl(Async)");
        }
        // verify the required parameter 'eui' is set
        if (eui == null) {
            throw new ApiException("Missing the required parameter 'eui' when calling updateGatewayControl(Async)");
        }
        
        com.squareup.okhttp.Call call = updateGatewayControlCall(body, eui, criteria, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * updateGatewayControl
     * This web service allows to update the control data of a gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param body The DTO JSON representation to put in the request body (required)
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @return TaskDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public TaskDto updateGatewayControl(GatewayControlDto body, String eui, Object criteria) throws ApiException {
        ApiResponse<TaskDto> resp = updateGatewayControlWithHttpInfo(body, eui, criteria);
        return resp.getData();
    }

    /**
     * updateGatewayControl
     * This web service allows to update the control data of a gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param body The DTO JSON representation to put in the request body (required)
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @return ApiResponse&lt;TaskDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<TaskDto> updateGatewayControlWithHttpInfo(GatewayControlDto body, String eui, Object criteria) throws ApiException {
        com.squareup.okhttp.Call call = updateGatewayControlValidateBeforeCall(body, eui, criteria, null, null);
        Type localVarReturnType = new TypeToken<TaskDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * updateGatewayControl (asynchronously)
     * This web service allows to update the control data of a gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param body The DTO JSON representation to put in the request body (required)
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call updateGatewayControlAsync(GatewayControlDto body, String eui, Object criteria, final ApiCallback<TaskDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = updateGatewayControlValidateBeforeCall(body, eui, criteria, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<TaskDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for updateGatewayCurrentConfiguration
     * @param body The DTO JSON representation to put in the request body (required)
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call updateGatewayCurrentConfigurationCall(GatewayConfigurationDto body, String eui, Object criteria, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/{eui}/configurations/current"
            .replaceAll("\\{" + "eui" + "\\}", apiClient.escapeString(eui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (criteria != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("criteria", criteria));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "PATCH", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call updateGatewayCurrentConfigurationValidateBeforeCall(GatewayConfigurationDto body, String eui, Object criteria, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling updateGatewayCurrentConfiguration(Async)");
        }
        // verify the required parameter 'eui' is set
        if (eui == null) {
            throw new ApiException("Missing the required parameter 'eui' when calling updateGatewayCurrentConfiguration(Async)");
        }
        
        com.squareup.okhttp.Call call = updateGatewayCurrentConfigurationCall(body, eui, criteria, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * updateGatewayCurrentConfiguration
     * This web service allows to update the current configuration of one gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;li&gt;The field &#x27;configVpn&#x27; can be set only with at least role ADMIN.&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param body The DTO JSON representation to put in the request body (required)
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @return TaskDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public TaskDto updateGatewayCurrentConfiguration(GatewayConfigurationDto body, String eui, Object criteria) throws ApiException {
        ApiResponse<TaskDto> resp = updateGatewayCurrentConfigurationWithHttpInfo(body, eui, criteria);
        return resp.getData();
    }

    /**
     * updateGatewayCurrentConfiguration
     * This web service allows to update the current configuration of one gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;li&gt;The field &#x27;configVpn&#x27; can be set only with at least role ADMIN.&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param body The DTO JSON representation to put in the request body (required)
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @return ApiResponse&lt;TaskDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<TaskDto> updateGatewayCurrentConfigurationWithHttpInfo(GatewayConfigurationDto body, String eui, Object criteria) throws ApiException {
        com.squareup.okhttp.Call call = updateGatewayCurrentConfigurationValidateBeforeCall(body, eui, criteria, null, null);
        Type localVarReturnType = new TypeToken<TaskDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * updateGatewayCurrentConfiguration (asynchronously)
     * This web service allows to update the current configuration of one gateway.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;li&gt;The field &#x27;configVpn&#x27; can be set only with at least role ADMIN.&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param body The DTO JSON representation to put in the request body (required)
     * @param eui Gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, gatewayEui} (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call updateGatewayCurrentConfigurationAsync(GatewayConfigurationDto body, String eui, Object criteria, final ApiCallback<TaskDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = updateGatewayCurrentConfigurationValidateBeforeCall(body, eui, criteria, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<TaskDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for updateGatewayManagement
     * @param body The DTO JSON representation to put in the request body (required)
     * @param eui Gateway EUI (required)
     * @param criteria A comma separated list of couples key&#x3D;value. A logical OR operation is used between the members. Example : criteria&#x3D;customerId&#x3D;10,fleetId&#x3D;78 &#x3D;&gt; (customerId&#x3D;10) OR (fleetId&#x3D;78) (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call updateGatewayManagementCall(GatewayManagementDto body, String eui, Object criteria, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/{eui}/management"
            .replaceAll("\\{" + "eui" + "\\}", apiClient.escapeString(eui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (criteria != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("criteria", criteria));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call updateGatewayManagementValidateBeforeCall(GatewayManagementDto body, String eui, Object criteria, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling updateGatewayManagement(Async)");
        }
        // verify the required parameter 'eui' is set
        if (eui == null) {
            throw new ApiException("Missing the required parameter 'eui' when calling updateGatewayManagement(Async)");
        }
        
        com.squareup.okhttp.Call call = updateGatewayManagementCall(body, eui, criteria, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * updateGatewayManagement
     * This web services allow to update the current gateway management data.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param body The DTO JSON representation to put in the request body (required)
     * @param eui Gateway EUI (required)
     * @param criteria A comma separated list of couples key&#x3D;value. A logical OR operation is used between the members. Example : criteria&#x3D;customerId&#x3D;10,fleetId&#x3D;78 &#x3D;&gt; (customerId&#x3D;10) OR (fleetId&#x3D;78) (optional)
     * @return TaskDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public TaskDto updateGatewayManagement(GatewayManagementDto body, String eui, Object criteria) throws ApiException {
        ApiResponse<TaskDto> resp = updateGatewayManagementWithHttpInfo(body, eui, criteria);
        return resp.getData();
    }

    /**
     * updateGatewayManagement
     * This web services allow to update the current gateway management data.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param body The DTO JSON representation to put in the request body (required)
     * @param eui Gateway EUI (required)
     * @param criteria A comma separated list of couples key&#x3D;value. A logical OR operation is used between the members. Example : criteria&#x3D;customerId&#x3D;10,fleetId&#x3D;78 &#x3D;&gt; (customerId&#x3D;10) OR (fleetId&#x3D;78) (optional)
     * @return ApiResponse&lt;TaskDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<TaskDto> updateGatewayManagementWithHttpInfo(GatewayManagementDto body, String eui, Object criteria) throws ApiException {
        com.squareup.okhttp.Call call = updateGatewayManagementValidateBeforeCall(body, eui, criteria, null, null);
        Type localVarReturnType = new TypeToken<TaskDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * updateGatewayManagement (asynchronously)
     * This web services allow to update the current gateway management data.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param body The DTO JSON representation to put in the request body (required)
     * @param eui Gateway EUI (required)
     * @param criteria A comma separated list of couples key&#x3D;value. A logical OR operation is used between the members. Example : criteria&#x3D;customerId&#x3D;10,fleetId&#x3D;78 &#x3D;&gt; (customerId&#x3D;10) OR (fleetId&#x3D;78) (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call updateGatewayManagementAsync(GatewayManagementDto body, String eui, Object criteria, final ApiCallback<TaskDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = updateGatewayManagementValidateBeforeCall(body, eui, criteria, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<TaskDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for updateGatewaysFirmware
     * @param file  (required)
     * @param euis A comma separated list of gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, firmwareFileName} (optional)
     * @param fields List of fields to display (optional)
     * @param when The date when to execute the update (EPOCH ms). Default value is current time. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call updateGatewaysFirmwareCall(File file, String euis, Object criteria, String fields, String when, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/gateways/firmware";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (criteria != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("criteria", criteria));
        if (euis != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("euis", euis));
        if (fields != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fields", fields));
        if (when != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("when", when));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (file != null)
        localVarFormParams.put("file", file);

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "multipart/form-data"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call updateGatewaysFirmwareValidateBeforeCall(File file, String euis, Object criteria, String fields, String when, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'file' is set
        if (file == null) {
            throw new ApiException("Missing the required parameter 'file' when calling updateGatewaysFirmware(Async)");
        }
        // verify the required parameter 'euis' is set
        if (euis == null) {
            throw new ApiException("Missing the required parameter 'euis' when calling updateGatewaysFirmware(Async)");
        }
        
        com.squareup.okhttp.Call call = updateGatewaysFirmwareCall(file, euis, criteria, fields, when, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * updateGatewaysFirmware
     * This web service allows starting a workflow. It returns the businessKey common to the created workflows.&lt;br&gt;The firmware file name will be formated according to this syntax :&lt;br&gt;originFileName_UUID.extension where UUID is a unique string&lt;br&gt;Example : firmware_2016.05v1.5_cd31160f-95b3-471b-a0a4-f524ed7d53b9.tar.gz&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param file  (required)
     * @param euis A comma separated list of gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, firmwareFileName} (optional)
     * @param fields List of fields to display (optional)
     * @param when The date when to execute the update (EPOCH ms). Default value is current time. (optional)
     * @return PaginatedDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PaginatedDto<TaskDto> updateGatewaysFirmware(File file, String euis, Object criteria, String fields, String when) throws ApiException {
        ApiResponse<PaginatedDto<TaskDto>> resp = updateGatewaysFirmwareWithHttpInfo(file, euis, criteria, fields, when);
        return resp.getData();
    }

    /**
     * updateGatewaysFirmware
     * This web service allows starting a workflow. It returns the businessKey common to the created workflows.&lt;br&gt;The firmware file name will be formated according to this syntax :&lt;br&gt;originFileName_UUID.extension where UUID is a unique string&lt;br&gt;Example : firmware_2016.05v1.5_cd31160f-95b3-471b-a0a4-f524ed7d53b9.tar.gz&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param file  (required)
     * @param euis A comma separated list of gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, firmwareFileName} (optional)
     * @param fields List of fields to display (optional)
     * @param when The date when to execute the update (EPOCH ms). Default value is current time. (optional)
     * @return ApiResponse&lt;PaginatedDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PaginatedDto<TaskDto>> updateGatewaysFirmwareWithHttpInfo(File file, String euis, Object criteria, String fields, String when) throws ApiException {
        com.squareup.okhttp.Call call = updateGatewaysFirmwareValidateBeforeCall(file, euis, criteria, fields, when, null, null);
        Type localVarReturnType = new TypeToken<PaginatedDto<TaskDto>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * updateGatewaysFirmware (asynchronously)
     * This web service allows starting a workflow. It returns the businessKey common to the created workflows.&lt;br&gt;The firmware file name will be formated according to this syntax :&lt;br&gt;originFileName_UUID.extension where UUID is a unique string&lt;br&gt;Example : firmware_2016.05v1.5_cd31160f-95b3-471b-a0a4-f524ed7d53b9.tar.gz&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param file  (required)
     * @param euis A comma separated list of gateway EUI (required)
     * @param criteria Task criteria. Pre-registered are :  {customerId, userId, fleetId, firmwareFileName} (optional)
     * @param fields List of fields to display (optional)
     * @param when The date when to execute the update (EPOCH ms). Default value is current time. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call updateGatewaysFirmwareAsync(File file, String euis, Object criteria, String fields, String when, final ApiCallback<PaginatedDto<TaskDto>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = updateGatewaysFirmwareValidateBeforeCall(file, euis, criteria, fields, when, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PaginatedDto<TaskDto>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
